//

/*
DWORD hgeClr( float A =1.f, float R =1.f, float G =1.f, float B =1.f)
{
	if(A < 0.f) A = 0.f; else if(A > 1.f) A = 1.f;
	if(R < 0.f) R = 0.f; else if(R > 1.f) R = 1.f;
	if(G < 0.f) G = 0.f; else if(G > 1.f) G = 1.f;
	if(B < 0.f) B = 0.f; else if(B > 1.f) B = 1.f;
	return ARGB( int(255 * A), int(255 * R), int(255 * G), int(255 * B) );
}
*/



// --------

//          ..
//float GameRectRX, GameRectRZ, GameRectRW, GameRectRH


//
int GameRectReal_Fru( float RealX, float RealZ, float tW, float tH)
{
	//  - ,    ..
	return RectPere( RealX, RealZ, tW, tH,
			GameRectRX, GameRectRZ, GameRectRW, GameRectRH);
}




void GameRectR_ProjToScreen( float RealX, float RealZ,
	float& scrX, float& scrY)
{
//GameRectRX, GameRectRZ, GameRectRW, GameRectRH // 
// GameRectX, GameRectY, GameRectW, GameRectH // 


	scrX = GameRectX + zn::Perc( RealX - GameRectRX, GameRectRW, GameRectW);
	scrY = GameRectY + zn::Perc( RealZ - GameRectRZ, GameRectRH, GameRectH);

	// OpenGL      scrY
	//scrY = g_wnd_h - scrY;
	//           ..
	if(1) scrY = GameRectY + GameRectH - (scrY - GameRectY);

}



/*
  () //  = ___    __
   ()   //  =      __
   () // 2 =      __
  ()// _ = 2    __
*/

void GameRect_ProjToReal( float scrX, float scrY,
	float& realX, float& realZ)
{
	//   OpenGL,    scrY
	if(1) scrY = GameRectH - (scrY - GameRectY);

	realX = zn::Perc( scrX - GameRectX, GameRectW, GameRectRW) + GameRectRX;
	//realZ = zn::Perc( scrY - GameRectY, GameRectH, GameRectRH) + GameRectRZ;
	realZ = zn::Perc( scrY, GameRectH, GameRectRH) + GameRectRZ; // scrY  
}


void ScreenRectToReal( float eX, float eY, float eW, float eH,
	float& rrX, float& rrZ, float& rrW, float& rrH)
{
	GameRect_ProjToReal( eX, eY, rrX, rrZ);
	GameRect_ProjToReal( eX + eW, eY + eH, rrW, rrH);

	//        
	float j = rrH; rrH = rrZ; rrZ = j; //  
	rrW -= rrX;
	rrH -= rrZ;
}




void MMapR_ProjToScreen( float RealX, float RealZ, float& scrX, float& scrY)
{
	scrX = MMapX + zn::Perc( RealX - 0.f, KlePoleW, MMapW);
	scrY = MMapY + zn::Perc( RealZ - 0.f, KlePoleH, MMapH);
	if(1) scrY = MMapY + MMapH - (scrY - MMapY);
}

void MMap_ProjToReal( float scrX, float scrY, float& realX, float& realZ)
{
	if(1) scrY = MMapH - (scrY - MMapY);
	realX = zn::Perc( scrX - MMapX, MMapW, KlePoleW) + 0.f;
	realZ = zn::Perc( scrY, MMapH, KlePoleH) + 0.f; // scrY  
}











void DrawMMap_dot( Fgr* pF, DWORD clr)
{
	if(!pF) return;
	//if( pF->NonForMMap() ) return;

	float ex, ey, ex2, ey2;
	MMapR_ProjToScreen(pF->ox - pF->haf, pF->oz - pF->haf,  ex, ey);
	MMapR_ProjToScreen(pF->ox + pF->haf, pF->oz + pF->haf,  ex2, ey2);

	an1_dr_r2( ex, ey, ex2+1, ey2, clr);
}






void spr_stre( float& ex, float& ey,  float& ex2, float& ey2,  DWORD tex, DWORD clr)
{
	glSetARGB( clr);
	NomBlend(38);
	if(tex == 0) pix1.off(); else pix1.use(tex);
	DrawQuad2D_2( ex,ey,  ex2,ey2);
	pix1.off();
}




void t_Render::Run()
{
	return;
/*
	//   -   
	//hge->Gfx_SetClipping( GameRectX, GameRectY, GameRectW, GameRectH);
	glScissor( GameRectX, GameRectY, GameRectW, GameRectH);
	glEnable( GL_SCISSOR_TEST);


	masKle.DrawLand(); //   // 
		//      Render.Add3( tex0_Rama, ... );



	float ex, ey, ex2, ey2;
	int i;


	if(lowNow > 0)  // --- --- --- 1-  ..
	{	for( i = 0; i < lowNow; i++)
		{
			if( low[i].scrCrd)
			{	ex = low[i].x1;  ey = low[i].z1;
				ex2 = low[i].x2;  ey2 = low[i].z2;
			}else
			{	GameRectR_ProjToScreen( low[i].x1, low[i].z1, ex, ey);
				GameRectR_ProjToScreen( low[i].x2, low[i].z2, ex2, ey2);
			}

			if( low[i].Tex == tex0_Rama)
			{	an1_dr_r2( ex,ey,  ex2,ey2, low[i].Clr);
			}else if( low[i].Tex == tex0_Ring)
			{	an1_dr_ring( ex,ey,  ex2,ey2, low[i].Clr, 0);
			}else
			{
				spr_stre( ex,ey,  ex2,ey2,  low[i].Tex,  low[i].Clr);
			}
		}
	}

	if(unitNow > 0)  // --- --- --- 2-   -   fgrXName_OnR
	{
		for( i = 0; i < unitNow; i++)
		{
			if(unit[i].pf)  unit[i].pf->TryOnRender();
		}
	}

	if(hiNow > 0)  // --- --- ---   ..
	{	for( i = 0; i < hiNow; i++)
		{
			if( hi[i].scrCrd)
			{	ex = hi[i].x1;  ey = hi[i].z1;
				ex2 = hi[i].x2;  ey2 = hi[i].z2;
			}else
			{	GameRectR_ProjToScreen( hi[i].x1, hi[i].z1, ex, ey);
				GameRectR_ProjToScreen( hi[i].x2, hi[i].z2, ex2, ey2);
			}

			if( hi[i].Tex == tex0_Rama)
			{	an1_dr_r2( ex,ey,  ex2,ey2, hi[i].Clr);
			}else if( hi[i].Tex == tex0_Ring)
			{	an1_dr_ring( ex,ey,  ex2,ey2, hi[i].Clr, 0);
			}else
			{
				spr_stre( ex,ey,  ex2,ey2,  hi[i].Tex,  hi[i].Clr);
			}
		}
	}



	//hge->Gfx_SetClipping(); // 
	glDisable( GL_SCISSOR_TEST);


	//   
	an1_dr_r( GameRectX, GameRectY, GameRectW, GameRectH, 0xFF778899);
	an1_dr_r( GameRectX+1, GameRectY+1, GameRectW-2, GameRectH-2, 0xFFFFFF00);
	an1_dr_r( GameRectX+3, GameRectY+3, GameRectW-6, GameRectH-6, 0xFF44AA44);





// ---     - 
//glViewport( 0, 0, g_wnd_w, g_wnd_h);
//Begin2D(0, g_wnd_w, 0, g_wnd_h );

	//    DrawMMap
	WarSides.DrawMMap(); //   ,  --.
//End2D();

*/
}




