// bf1_geom.h
// ------
//      .
//   ...




//       4      
void FreeDotsRect( int X1, int Y1, int X2, int Y2,
		int& RectX, int& RectY, int& RectW, int& RectH)
{
	int t1;
	if(X1 > X2){ t1= X2; X2 = X1; X1 = t1;}
	if(Y1 > Y2){ t1= Y2; Y2 = Y1; Y1 = t1;}
	RectX = X1;
	RectY = Y1;
	RectW = X2 - X1;
	RectH = Y2 - Y1;

}




// - 
int RectPere(float x1, float y1, float w1, float h1,
		float x2, float y2, float w2, float h2)
{
	// 
	x1 += w1/2.f;  y1 += h1/2.f;//
	x2 += w2/2.f;  y2 += h2/2.f;

	if( (zn::Absf(x1 - x2) <= (w1+w2)/2.f) && (zn::Absf(y1 - y2) <= (h1+h2)/2.f)
	) return 1;
return 0;
}



/*

	// RectPereRect // BFTileInRect
int BFTileInRect( int tX, int tDn, int tileW, int tileH,
					int RX, int RNiz, int RW, int RH)
{
//   .  //    RectPere

	// Tile.  .  .  // -  ()
	int tX2 = tX + tileW;
	int tY2 = tDn + tileH;
	int RX2 = RX + RW;
	//int RY2 = RNiz + RH;

	// zn::Ineri(...)     Base Force

	if(  zn::Ineri( tX, RX, RW)  ||  zn::Ineri( tX2, RX, RW)  )
	{
	//         ( .  )

		if( (tDn > (RNiz + RH))  ||  (tY2 < RNiz) ) return 0; //   -
		else return 1;
	}

	if(  zn::Ineri( tDn, RNiz, RH)  ||  zn::Ineri( tY2, RNiz, RH)  )
	{
	//        

		if( (tX > RX2)  ||  (tX2 < RX) ) return 0; // -  
		else return 1;
	}

	if((tX < RX) &&(tX2 > RX2)) return 1; //     

return 0;
}

*/



int BFTileOver( int tX, int tDn, int tileW, int tileH,
					int RX, int RNiz, int RW, int RH)
{
	if(    ((tX < RX) &&((tX + tileW) > (RX + RW)))
		&&((tDn < RNiz) &&((tDn + tileH) > (RNiz + RH)))    )  return 1;

return 0;
}



void BFTileXYf( float& getX, float& getY, int OfsetNom,
	float poleX, float poleY, float kleW, float kleH,  int xTKlv, int yTKlv,  int GLY=1 )
{
	getX = (float(OfsetNom % xTKlv) * kleW) + poleX;

	int sY = OfsetNom / xTKlv; //   
	if(GLY) sY = (yTKlv-1) - sY; // 
	getY = float(sY) * kleH + poleY;
}


void BFTileXY( int& getX, int& getY, int OfsetNom,
				int poleX, int poleY, int kleW, int kleH,  int xTKlv, int yTKlv,  int GLY=1 )
{
	getX = ((OfsetNom % xTKlv) * kleW) + (poleX);

	getY = (OfsetNom / xTKlv); //   
	if(GLY) getY = (yTKlv-1) - getY; // 
	getY = (getY * kleH) + (poleY);
}


void BFHexXY( int& getX, int& getY, int OfsetNom,
				int poleX, int poleY, int kleW, int kleH,  int xTKlv, int yTKlv,  int GLY=1 )
{
	getX = ((OfsetNom % xTKlv) * kleW) + (poleX);

	getY = (OfsetNom / xTKlv); //   
	if(GLY) getY = (yTKlv-1) - getY; // 
	getY = (getY * kleH) + (poleY);

	//     
	if(   ( OfsetNom % (xTKlv * 2)) > (xTKlv-1)   ) // transX -= (kleW*0.5f);
	{
		getX -= (kleW * 0.5f); //FMI(kleW, 0.5f);
	}
}





//        (OfsetNom & OfsetN2)    
void BFHexXY_Line( int OfsetNom, int OfsetN2, int& x1, int& y1, int& x2, int& y2,
				  int poleX, int poleY, int kleW, int kleH,  int xTKlv, int yTKlv,  int centruem=1)
{
	BFHexXY( x1, y1, OfsetNom,	poleX, poleY, kleW, kleH, xTKlv, yTKlv);
	BFHexXY( x2, y2, OfsetN2,	poleX, poleY, kleW, kleH, xTKlv, yTKlv);

	if(centruem)
	{
	x1 += (kleW/2);		y1 += (kleH/2);
	x2 += (kleW/2);		y2 += (kleH/2);
	}
}





// -   
int inRectf(float fpX, float fpY,
				  float rtX, float rtY, float rtW, float rtH)
{
	if(fpX < rtX) return 0;
	if(fpY < rtY) return 0;
	if(fpX > (rtW + rtX)) return 0;
	if(fpY > (rtH + rtY)) return 0;
return 1;
}
int inRect(int pX, int pY,
				  int rtX, int rtY, int rtW, int rtH)
{
	if(pX < rtX) return 0;
	if(pY < rtY) return 0;
	if(pX > (rtW + rtX)) return 0;
	if(pY > (rtH + rtY)) return 0;
return 1;
}









// --------
// ,        .
//     -     OpenGL  
//   . -    .

	//  -  (  ) (-1   )
	//  - X Z (. ),   XZ  - ...
	//   - -  .
int LentaPoleFrom0_NomYchUnder2( int xe, int ye,
	   int poleX, int poleNiz, int tileW, int tileH, int poleXTiles, int poleYTiles)
{
// poleNiz   .

		//    8 ..
		// poleXTiles as 4
		// poleYTiles as 2
		// 0 1 2 3
		// 4 5 6 7
		// (poleX, poleNiz)    (- 0)

	if(tileW < 1) return -1; //     ,   -
	if(tileH < 1) return -1;

		int oX = xe - poleX; // -     
		if(oX < 1) return -1;

		int oY = ye - poleNiz;
		if(oY < 1) return -1;

		int poleW = poleXTiles * tileW; //    
		if(xe > (poleX + poleW)) return -1;

		int poleH = poleYTiles * tileH; //  
		if(ye > (poleNiz + poleH)) return -1;

		//      -     ..
		int nomLine = (oY / tileH); //       

		int nomT = (nomLine * poleXTiles)  + (oX / tileW); //    "nomT"
	return nomT;
}






/*
//   OpenGL ,     -    
//  -  .

			//  -  (  ) (-1   )
			//    ,     - ...
int LentaPoleFrom0_NomYchUnder( int xe, int ye,
					   int poleX, int poleNiz, int tileW, int tileH, int poleXTiles, int poleYTiles)
{
		//    8 ..
		// poleXTiles as 4
		// poleYTiles as 2
		// 0 1 2 3
		// 4 5 6 7
		// (poleX, poleNiz)    5-  (- 4)
	if(xe < 0) return -1; //      
	if(ye < 0) return -1; //      
	if(tileW < 2) return -1; //      ,   -
	if(tileH < 2) return -1;

		int oX = xe - poleX; // -     
		if(oX < 1) return -1;

		int oY = ye - poleNiz;
		if(oY < 1) return -1;

		int poleW = poleXTiles * tileW; //    
		if(xe > (poleX + poleW)) return -1;

		int poleH = poleYTiles * tileH; //    
		if(ye > (poleNiz + poleH)) return -1;

		//      -     ..
		int nomLine = (oY / tileH); //       
			nomLine = (poleYTiles - 1) - nomLine; // 

		int nomT = (nomLine * poleXTiles)  + (oX / tileW); //    "nomT"
	return nomT;
}
*/




