
class Box0
{
public:
float* px; //  -
float* py;
float* pz;
float* phx;
float* phy;
float* phz;
	Box0() { Main_Done = 1; }
	Box0(float& X, float& Y, float& Z,  float& HX, float& HY, float& HZ)
			{ px=&X; py=&Y; pz=&Z;  phx=&HX; phy=&HY; phz=&HZ; }


	inline float x() {return *px;}
	inline float y() {return *py;}
	inline float z() {return *pz;}

	inline float hx() {return *phx;}
	inline float hy() {return *phy;}
	inline float hz() {return *phz;}

	// GetVws
//	inline float gVws() {return Heit;}

	inline float gMinX() {return *px - *phx;}
	inline float gMaxX() {return *px + *phx;}

	inline float gMinY() {return *py - *phy;}
	inline float gMaxY() {return *py + *phy;}

	inline float gMinZ() {return *pz - *phz;}
	inline float gMaxZ() {return *pz + *phz;}



	void HalfsUrez(float zna)
	{
		*phx -= zna; // *phx  (       )
		*phy -= zna;
		*phz -= zna;
	}

/*
	//static
	void SetFromDia(float p1X, float p1Y, float p1Z,  float p2X, float p2Y, float p2Z)
	{
		halfX = zn::Absf(p1X - p2X);
		halfY = zn::Absf(p1Y - p2Y);
		halfZ = zn::Absf(p1Z - p2Z);

		if(p1X > p2X) x = p2X + halfX;	else x = p1X + halfX;
		if(p1Y > p2Y) y = p2Y + halfY;	else y = p1Y + halfY;
		if(p1Z > p2Z) z = p2Z + halfZ;	else z = p1Z + halfZ;

		vec3 an( halfX, halfY, halfZ );
		Radius = = zn::Absf( an.len() );
		Heit = halfY*2.f;
	} */


};





namespace fru0
{


class CFrustum 
{
	public:

		CFrustum();
		~CFrustum();

		void Update();
		bool CubeInFrustum( float x, float y, float z, float size );

		bool PointInFrustum( float x, float y, float z );
		bool LineInFrustum(float a[3], float b[3]);

		bool Box0_InFrustum( Box0* box );
		//bool Gbr_InFrustum( float gMinX, float gMinY, float gMinZ,  float gMaxX, float gMaxY, float gMaxZ );
		bool Gbr_InFrustum( vec3 gMin, vec3 gMax);



	private:

		float m_Frustum[6][4];
};





enum FrustumSide
{
	RIGHT	= 0,		// The RIGHT side of the frustum
	LEFT	= 1,		// The LEFT	 side of the frustum
	BOTTOM	= 2,		// The BOTTOM side of the frustum
	TOP		= 3,		// The TOP side of the frustum
	BACK	= 4,		// The BACK	side of the frustum
	FRONT	= 5			// The FRONT side of the frustum
}; 

enum PlaneData
{
	A = 0,				// The X value of the plane's normal
	B = 1,				// The Y value of the plane's normal
	C = 2,				// The Z value of the plane's normal
	D = 3				// The distance the plane is from the origin
};

void NormalizePlane(float frustum[6][4], int side)
{
	float magnitude = (float)sqrt( frustum[side][A] * frustum[side][A] + 
								   frustum[side][B] * frustum[side][B] + 
								   frustum[side][C] * frustum[side][C] );

	frustum[side][A] /= magnitude;
	frustum[side][B] /= magnitude;
	frustum[side][C] /= magnitude;
	frustum[side][D] /= magnitude; 

}


CFrustum::CFrustum()
{
}

CFrustum::~CFrustum()
{
}

void CFrustum::Update()
{
	float   proj[16];// This will hold our projection matrix
	float   modl[16];// This will hold our modelview matrix
	float   clip[16];// This will hold the clipping planes

	glGetFloatv( GL_PROJECTION_MATRIX, proj );
	glGetFloatv( GL_MODELVIEW_MATRIX, modl );


	clip[ 0] = modl[ 0] * proj[ 0] + modl[ 1] * proj[ 4] + modl[ 2] * proj[ 8] + modl[ 3] * proj[12];
	clip[ 1] = modl[ 0] * proj[ 1] + modl[ 1] * proj[ 5] + modl[ 2] * proj[ 9] + modl[ 3] * proj[13];
	clip[ 2] = modl[ 0] * proj[ 2] + modl[ 1] * proj[ 6] + modl[ 2] * proj[10] + modl[ 3] * proj[14];
	clip[ 3] = modl[ 0] * proj[ 3] + modl[ 1] * proj[ 7] + modl[ 2] * proj[11] + modl[ 3] * proj[15];

	clip[ 4] = modl[ 4] * proj[ 0] + modl[ 5] * proj[ 4] + modl[ 6] * proj[ 8] + modl[ 7] * proj[12];
	clip[ 5] = modl[ 4] * proj[ 1] + modl[ 5] * proj[ 5] + modl[ 6] * proj[ 9] + modl[ 7] * proj[13];
	clip[ 6] = modl[ 4] * proj[ 2] + modl[ 5] * proj[ 6] + modl[ 6] * proj[10] + modl[ 7] * proj[14];
	clip[ 7] = modl[ 4] * proj[ 3] + modl[ 5] * proj[ 7] + modl[ 6] * proj[11] + modl[ 7] * proj[15];

	clip[ 8] = modl[ 8] * proj[ 0] + modl[ 9] * proj[ 4] + modl[10] * proj[ 8] + modl[11] * proj[12];
	clip[ 9] = modl[ 8] * proj[ 1] + modl[ 9] * proj[ 5] + modl[10] * proj[ 9] + modl[11] * proj[13];
	clip[10] = modl[ 8] * proj[ 2] + modl[ 9] * proj[ 6] + modl[10] * proj[10] + modl[11] * proj[14];
	clip[11] = modl[ 8] * proj[ 3] + modl[ 9] * proj[ 7] + modl[10] * proj[11] + modl[11] * proj[15];

	clip[12] = modl[12] * proj[ 0] + modl[13] * proj[ 4] + modl[14] * proj[ 8] + modl[15] * proj[12];
	clip[13] = modl[12] * proj[ 1] + modl[13] * proj[ 5] + modl[14] * proj[ 9] + modl[15] * proj[13];
	clip[14] = modl[12] * proj[ 2] + modl[13] * proj[ 6] + modl[14] * proj[10] + modl[15] * proj[14];
	clip[15] = modl[12] * proj[ 3] + modl[13] * proj[ 7] + modl[14] * proj[11] + modl[15] * proj[15];




	// This will extract the RIGHT side of the frustum
	m_Frustum[RIGHT][A] = clip[ 3] - clip[ 0];
	m_Frustum[RIGHT][B] = clip[ 7] - clip[ 4];
	m_Frustum[RIGHT][C] = clip[11] - clip[ 8];
	m_Frustum[RIGHT][D] = clip[15] - clip[12];

	// Normalize the RIGHT side
	NormalizePlane(m_Frustum, RIGHT);

	// This will extract the LEFT side of the frustum
	m_Frustum[LEFT][A] = clip[ 3] + clip[ 0];
	m_Frustum[LEFT][B] = clip[ 7] + clip[ 4];
	m_Frustum[LEFT][C] = clip[11] + clip[ 8];
	m_Frustum[LEFT][D] = clip[15] + clip[12];

	// Normalize the LEFT side
	NormalizePlane(m_Frustum, LEFT);

	// This will extract the BOTTOM side of the frustum
	m_Frustum[BOTTOM][A] = clip[ 3] + clip[ 1];
	m_Frustum[BOTTOM][B] = clip[ 7] + clip[ 5];
	m_Frustum[BOTTOM][C] = clip[11] + clip[ 9];
	m_Frustum[BOTTOM][D] = clip[15] + clip[13];

	// Normalize the BOTTOM side
	NormalizePlane(m_Frustum, BOTTOM);

	// This will extract the TOP side of the frustum
	m_Frustum[TOP][A] = clip[ 3] - clip[ 1];
	m_Frustum[TOP][B] = clip[ 7] - clip[ 5];
	m_Frustum[TOP][C] = clip[11] - clip[ 9];
	m_Frustum[TOP][D] = clip[15] - clip[13];

	// Normalize the TOP side
	NormalizePlane(m_Frustum, TOP);

	// This will extract the BACK side of the frustum
	m_Frustum[BACK][A] = clip[ 3] - clip[ 2];
	m_Frustum[BACK][B] = clip[ 7] - clip[ 6];
	m_Frustum[BACK][C] = clip[11] - clip[10];
	m_Frustum[BACK][D] = clip[15] - clip[14];

	// Normalize the BACK side
	NormalizePlane(m_Frustum, BACK);

	// This will extract the FRONT side of the frustum
	m_Frustum[FRONT][A] = clip[ 3] + clip[ 2];
	m_Frustum[FRONT][B] = clip[ 7] + clip[ 6];
	m_Frustum[FRONT][C] = clip[11] + clip[10];
	m_Frustum[FRONT][D] = clip[15] + clip[14];

	// Normalize the FRONT side
	NormalizePlane(m_Frustum, FRONT);

}






bool CFrustum::CubeInFrustum( float x, float y, float z, float size )
{
	for(int i = 0; i < 6; i++ )
	{
		if(m_Frustum[i][A] * (x - size) + m_Frustum[i][B] * (y - size) + m_Frustum[i][C] * (z - size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x + size) + m_Frustum[i][B] * (y - size) + m_Frustum[i][C] * (z - size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x - size) + m_Frustum[i][B] * (y + size) + m_Frustum[i][C] * (z - size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x + size) + m_Frustum[i][B] * (y + size) + m_Frustum[i][C] * (z - size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x - size) + m_Frustum[i][B] * (y - size) + m_Frustum[i][C] * (z + size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x + size) + m_Frustum[i][B] * (y - size) + m_Frustum[i][C] * (z + size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x - size) + m_Frustum[i][B] * (y + size) + m_Frustum[i][C] * (z + size) + m_Frustum[i][D] > 0)
		   continue;
		if(m_Frustum[i][A] * (x + size) + m_Frustum[i][B] * (y + size) + m_Frustum[i][C] * (z + size) + m_Frustum[i][D] > 0)
		   continue;

		return false;
	}

	return true;
}





bool CFrustum::PointInFrustum( float x, float y, float z )
{
	int i;

	for( i = 0; i < 6; i++ )
	{
		if(m_Frustum[i][0]*x + m_Frustum[i][1]*y + m_Frustum[i][2]*z + m_Frustum[i][3] <= 0 )	return false;
	}
	return true;

}






bool CFrustum::LineInFrustum(float a[3], float b[3])
{
	float fa, fb;
	unsigned int i;

	for (i = 0; i<6; i++)
	{
		fa = m_Frustum[i][0]*a[0] + m_Frustum[i][1]*a[1] + m_Frustum[i][2]*a[2] + m_Frustum[i][3];
		fb = m_Frustum[i][0]*b[0] + m_Frustum[i][1]*b[1] + m_Frustum[i][2]*b[2] + m_Frustum[i][3];
		
		if(fa*fb < 0) return true;
	}
	return false;
}





//bool CFrustum::RightParallelepipedInFrustum(float Min[3], float Max[3])
bool CFrustum::Box0_InFrustum( Box0* box )
{
	float Min[3];
	float Max[3];

	Min[0] = box->gMinX();	Min[1] = box->gMinY();	Min[2] = box->gMinZ();
	Max[0] = box->gMaxX();	Max[1] = box->gMaxY();	Max[2] = box->gMaxZ();


	unsigned int i;//CurrentPlane

	for (i = 0; i<6; i++)
	{
		if (m_Frustum[i][0]*Min[0]+m_Frustum[i][1]*Max[1]+m_Frustum[i][2]*Min[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Min[0]+m_Frustum[i][1]*Max[1]+m_Frustum[i][2]*Max[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Max[0]+m_Frustum[i][1]*Max[1]+m_Frustum[i][2]*Max[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Max[0]+m_Frustum[i][1]*Max[1]+m_Frustum[i][2]*Min[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Max[0]+m_Frustum[i][1]*Min[1]+m_Frustum[i][2]*Min[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Max[0]+m_Frustum[i][1]*Min[1]+m_Frustum[i][2]*Max[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Min[0]+m_Frustum[i][1]*Min[1]+m_Frustum[i][2]*Max[2]+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*Min[0]+m_Frustum[i][1]*Min[1]+m_Frustum[i][2]*Min[2]+m_Frustum[i][3]>0)
			continue;

		return false;
	}
	return true;
}



//bool CFrustum::Gbr_InFrustum( float gMinX, float gMinY, float gMinZ,  float gMaxX, float gMaxY, float gMaxZ )
bool CFrustum::Gbr_InFrustum( vec3 gMin, vec3 gMax)
{
	unsigned int i;//CurrentPlane

	for (i = 0; i<6; i++)
	{
		if (m_Frustum[i][0]*gMin.x+m_Frustum[i][1]*gMax.y+m_Frustum[i][2]*gMin.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMin.x+m_Frustum[i][1]*gMax.y+m_Frustum[i][2]*gMax.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMax.x+m_Frustum[i][1]*gMax.y+m_Frustum[i][2]*gMax.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMax.x+m_Frustum[i][1]*gMax.y+m_Frustum[i][2]*gMin.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMax.x+m_Frustum[i][1]*gMin.y+m_Frustum[i][2]*gMin.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMax.x+m_Frustum[i][1]*gMin.y+m_Frustum[i][2]*gMax.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMin.x+m_Frustum[i][1]*gMin.y+m_Frustum[i][2]*gMax.z+m_Frustum[i][3]>0)
			continue;
		if (m_Frustum[i][0]*gMin.x+m_Frustum[i][1]*gMin.y+m_Frustum[i][2]*gMin.z+m_Frustum[i][3]>0)
			continue;

		return false;
	}
	return true;
}




} // end namespace fru0



fru0::CFrustum Fru1;


