//
// @@MSpr










// ----------

typedef BYTE t_3Byte[3];



//#ifndef GL_EXT_texture_edge_clamp
//#define GL_EXT_texture_edge_clamp
#ifndef GL_CLAMP_TO_EDGE_EXT
#define GL_CLAMP_TO_EDGE_EXT 0x812F

#endif


		//    "class OGL"
int glob_vpLvl = 0;
int glob_vpInt20_4[20][4];//320 bytes



class OGL
{
public:
	//    .
	//  -,     VBO.



		// 0= GL_CLAMP_TO_EDGE_EXT.,     .
static void TexRepeat(int rep=1)
{
	switch(rep)
	{
	case 0:
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE_EXT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE_EXT);
	break;
	default:
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	break;
	}

}



static void TexClamp(int DoClamp=1)
{
	if( DoClamp )
	{
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE_EXT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE_EXT);
	} else {
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	}
}

static void TexClampX()
{	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE_EXT);
}
static void TexClampY()
{	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE_EXT);
}




static float TexU_ZeroToCntrTile( int nomFrom1, int tilesKlv )
{
	if( nomFrom1 < 1 ) return 0.f;
	if( nomFrom1 > tilesKlv ) return 0.f;

	float tmpW = 1.f / float(tilesKlv);
	float hW = tmpW / 2.f;
	tmpW = float(nomFrom1 - 1) * tmpW;
	return tmpW + hW;
}




	//   -   ...
static void Tex_PushMatrix()
{
	glMatrixMode(GL_TEXTURE);		glPushMatrix(); // --- TEX PUSH ---
	glMatrixMode(GL_MODELVIEW); // 
}

static void Tex_PushMatrix_Trans(float tx, float ty)
{
	glMatrixMode(GL_TEXTURE);		glPushMatrix(); // --- TEX PUSH ---
	glTranslatef(tx, ty, 0.f);
	glMatrixMode(GL_MODELVIEW); // 
}

static void Tex_PushMatrix_Scale(float sx, float sy)
{
	glMatrixMode(GL_TEXTURE);		glPushMatrix(); // --- TEX PUSH ---
	glScalef(sx, sy, 1.f);
	glMatrixMode(GL_MODELVIEW); // 
}


//         .
static void Tex_PopMatrix(int sloFromZero=0)
{
	//TexUnit(sloFromZero);

	glMatrixMode(GL_TEXTURE);		glPopMatrix(); // --- TEX POP ---

	//TexUnit(0); //          ...

	glMatrixMode(GL_MODELVIEW);

}







static void Tex_MatrixTrans(float tx, float ty)
{
	glMatrixMode(GL_TEXTURE);	glTranslatef(tx, ty, 0.f);
	glMatrixMode(GL_MODELVIEW);
}

static void Tex_MatrixRot(float angle) //  -
{
	// metka_
	glMatrixMode(GL_TEXTURE);	glRotatef( angle,  0.f, 0.f, 1.f );
	glMatrixMode(GL_MODELVIEW);
}

static void Tex_MatrixScale(float sx, float sy)
{
	glMatrixMode(GL_TEXTURE);	glScalef(sx, sy, 1.f);
	glMatrixMode(GL_MODELVIEW);
}






// Layer_
static void L_Modulate()
{ glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE ); }

static void L_Decal()
{ glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL ); }

static void L_BlendClr(float* pRGBA = NULL)
{
	static float pRGBAzero[4] = {0.f, 0.f, 0.f, 0.f};
	if( ! pRGBA )
		glTexEnvfv( GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, pRGBAzero );
	else glTexEnvfv( GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, pRGBA );

	glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND );
}

static void L_Replace()
{ glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE ); }

static void L_Add()
{ glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD ); }




	//  - -   "   " GL_EYE_LINEAR
static void TexGenMode_GlazLinear()
{
	//    ,  -      
	glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR );
	glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR );
	glTexGeni( GL_R, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR );
	glTexGeni( GL_Q, GL_TEXTURE_GEN_MODE, GL_EYE_LINEAR );
}

	//  - -  -      
static void TexGenGlazPlane_StartMatrix()
{
	static float fr1[4] = {1.f, 0.f, 0.f, 0.f};
	static float fr2[4] = {0.f, 1.f, 0.f, 0.f};
	static float fr3[4] = {0.f, 0.f, 1.f, 0.f};
	static float fr4[4] = {0.f, 0.f, 0.f, 1.f};

	glTexGenfv( GL_S, GL_EYE_PLANE, fr1 );
	glTexGenfv( GL_T, GL_EYE_PLANE, fr2 );
	glTexGenfv( GL_R, GL_EYE_PLANE, fr3 );
	glTexGenfv( GL_Q, GL_EYE_PLANE, fr4 );
}

//        Layer or TexLayer
//        ()
//         ( )
//           TexSlo_
//         TexObj_
static void TexAutoSTRQ(short sE=1, short tE=1, short rE=1, short qE=1)
{
	if(sE) glEnable(GL_TEXTURE_GEN_S); else glDisable(GL_TEXTURE_GEN_S);
	if(tE) glEnable(GL_TEXTURE_GEN_T); else glDisable(GL_TEXTURE_GEN_T);
	if(rE) glEnable(GL_TEXTURE_GEN_R); else glDisable(GL_TEXTURE_GEN_R);
	if(qE) glEnable(GL_TEXTURE_GEN_Q); else glDisable(GL_TEXTURE_GEN_Q);
}






static void EnSferMapSlo(int slo) // slo 0,,7
{
	//TexUnit(slo);

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
}



static void DisSferMapSlo(int slo) // slo 0,,7
{
	//TexUnit(slo);
	glDisable(GL_TEXTURE_GEN_S);
	glDisable(GL_TEXTURE_GEN_T);
}








	//     TexEnv  GL_BLEND (    )
static void Tex_SloEnvClr(int slo, float* pRGBA )
{
//	TexUnit(slo);
	glTexEnvfv( GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, pRGBA );
	glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND );
		//    GL_BLEND   GL_TEXTURE_ENV_COLOR
		//----------
}


	//    _ENV_COLOR   TexEnv  _MODULATE
static void Tex_SloEnvClrZero(int slo)
{
	static float pClr0[4] = {0.f, 0.f, 0.f, 0.f};
	//TexUnit(slo);
	glTexEnvfv( GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, pClr0 );
	glTexEnvi ( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
}








static void GLDisLitX( UINT nom=100)//  .
{
	if(nom > 99)
	{
		glDisable(GL_LIGHT0);	glDisable(GL_LIGHT1);
		glDisable(GL_LIGHT2);	glDisable(GL_LIGHT3);
		glDisable(GL_LIGHT4);	glDisable(GL_LIGHT5);
		glDisable(GL_LIGHT6);	glDisable(GL_LIGHT7);
		return;
	}

	switch(nom)
	{
	case 0: glDisable(GL_LIGHT0); break;
	case 1: glDisable(GL_LIGHT1); break;
	case 2: glDisable(GL_LIGHT2); break;
	case 3: glDisable(GL_LIGHT3); break;
	case 4: glDisable(GL_LIGHT4); break;
	case 5: glDisable(GL_LIGHT5); break;
	case 6: glDisable(GL_LIGHT6); break;
	case 7: glDisable(GL_LIGHT7); break;
	}
}









static void KlientVertex( vec3* masVert )
{
	if( ! masVert ) return;
	glVertexPointer( 3, GL_FLOAT, 0, &masVert[0].x );
		glEnableClientState( GL_VERTEX_ARRAY );

}
/*
static int KlientVertex( GLuint vertBuf_ID )
{
	if( ! vertBuf_ID ) return 0;
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, vertBuf_ID );
		glVertexPointer( 3, GL_FLOAT, 0, NULL );
		glEnableClientState( GL_VERTEX_ARRAY );
	return 1;
}
*/

	//   glDisableClientState( GL_VERTEX_ARRAY );
static void KlientVertexOFF()
{
	glDisableClientState( GL_VERTEX_ARRAY );
}





static int KlientNrm( vec3* masNrm )
{
	if( ! masNrm ) return 0;
	glNormalPointer(GL_FLOAT, 0, &masNrm[0].x );
	glEnableClientState(GL_NORMAL_ARRAY);
	return 1;
}
/*
static int KlientNrm( GLuint nrmBuf_ID )
{
	if( ! nrmBuf_ID ) return 0;
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, nrmBuf_ID );
		glNormalPointer(GL_FLOAT, 0, NULL );
		glEnableClientState(GL_NORMAL_ARRAY);
	return 1;
}
*/

static void KlientNrmOFF()
{
	glDisableClientState( GL_NORMAL_ARRAY );
}







static void KlientColorBytes( t_3Byte* masClr )
{
	if( ! masClr ) return;
	glColorPointer( 3, GL_UNSIGNED_BYTE, 0, &masClr[0][0] );
		glEnableClientState( GL_COLOR_ARRAY );
}
/*
static int KlientColorBytes( GLuint clrBuf_ID )
{
	if( ! clrBuf_ID ) return 0;
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, clrBuf_ID );
		glColorPointer( 3, GL_UNSIGNED_BYTE, 0, NULL );
		glEnableClientState( GL_COLOR_ARRAY );
	return 1;
}
*/

//static void KlientColor4Bytes( t_4Byte* masClr )
static void KlientColor4Bytes( BYTE* masClr )
{
	if( ! masClr ) return;
	glColorPointer( 4, GL_UNSIGNED_BYTE, 0, masClr );
		glEnableClientState( GL_COLOR_ARRAY );
}
/*
static int KlientColor4Bytes( GLuint clrBuf_ID )
{
	if( ! clrBuf_ID ) return 0;
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, clrBuf_ID );
		glColorPointer( 4, GL_UNSIGNED_BYTE, 0, NULL );
		glEnableClientState( GL_COLOR_ARRAY );
	return 1;
}
*/
static void KlientColorOFF()
{
	glDisableClientState( GL_COLOR_ARRAY );
}





/*
	//      
	//  -        ...
static void KlientTexSlo( UINT nomFr0)
{
	if(nomFr0 > 7) return;
	glClientActiveTextureARB( GL_TEXTURE0_ARB + nomFr0 );
}
*/





static void KlientTexCoord(int nomFr0, vec2* uv, int texC_ON=1)
{
	if(! uv) return;
//	KlientTexSlo( nomFr0);
		glTexCoordPointer( 2, GL_FLOAT, 0, uv);

	if(texC_ON) glEnableClientState( GL_TEXTURE_COORD_ARRAY );
}

/*
static int KlientTexCoord(int nomFr0, GLuint bufTC_ID, int texC_ON=1)
{
	if( ! bufTC_ID) return 0;
	KlientTexSlo( nomFr0);
		glBindBufferARB( GL_ARRAY_BUFFER_ARB, bufTC_ID );
		glTexCoordPointer( 2, GL_FLOAT, 0, NULL);

	if(texC_ON) glEnableClientState( GL_TEXTURE_COORD_ARRAY );
	return 1;
}
*/


	//      ,      .
static void KlientTexC_ON( UINT nomFr0)
{
//	KlientTexSlo( nomFr0);
		glEnableClientState( GL_TEXTURE_COORD_ARRAY );
}

	//      -   TexCoord_KlientON
static void KlientTexC_OFF( UINT nomFr0)
{
//	KlientTexSlo( nomFr0);
		glDisableClientState( GL_TEXTURE_COORD_ARRAY );
}













		//      ...
	static void Tex2DGenTC_ObjXZ( float* xCoef, float* zCoef)
	{
		glTexGeni( GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
		glTexGeni( GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
			glTexGenfv( GL_S, GL_OBJECT_PLANE, xCoef);
			glTexGenfv( GL_T, GL_OBJECT_PLANE, zCoef);
		glEnable(GL_TEXTURE_GEN_S);	glEnable(GL_TEXTURE_GEN_T);
	}

	static void Tex2DGenTC_Dis()
	{
		glDisable(GL_TEXTURE_GEN_S);	glDisable(GL_TEXTURE_GEN_T);
	}







/*


		//   Enable _INDEX_ARRAY ...  UNSIGNED_INT only
		//       .
	static int Bind_ElemARB( GLuint elemBO_ID )
	{
		if( ! elemBO_ID ) return 0;
			//      - elemBO_ID   ...
			//-------

		//     ,    ,  

		glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, elemBO_ID );
		//CheckLog_GLError( 51128 );

			glIndexPointer( GL_UNSIGNED_INT, 0, NULL );
		//CheckLog_GLError( 51130 );//GL_INVALID_ENUM - GLenum Argument out of range (51130)

			glEnableClientState( GL_INDEX_ARRAY );


		return 1;
	}

		//   Disable _INDEX_ARRAY
	static void BindClear_ElemARB()
	{
		glBindBufferARB( GL_ELEMENT_ARRAY_BUFFER_ARB, NULL );
		glDisableClientState( GL_INDEX_ARRAY );
	}




*/

static void VPortPush()
{
	if(glob_vpLvl > 19) return;
	glGetIntegerv(GL_VIEWPORT, &glob_vpInt20_4[glob_vpLvl][0] );	glob_vpLvl += 1;
}
static void VPortPush_SetFullScr()
{
	if(glob_vpLvl > 19) return;
	glGetIntegerv(GL_VIEWPORT, &glob_vpInt20_4[glob_vpLvl][0] );	glob_vpLvl += 1;

	glViewport(0,0, g_wnd_w, g_wnd_h);
}
static void VPortPop()
{
	if(glob_vpLvl < 1) return;
	glob_vpLvl -= 1;
	glViewport(
		glob_vpInt20_4[glob_vpLvl][0],
		glob_vpInt20_4[glob_vpLvl][1],
		glob_vpInt20_4[glob_vpLvl][2],
		glob_vpInt20_4[glob_vpLvl][3] );
}



};
// class OGL


































// --------  sprite rose360
//   .


//       
//const WORD  ugRoseQ00 = 225;
//const WORD  ugRoseQ10 = 315;
//const WORD  ugRoseQ11 =  45;
//const WORD  ugRoseQ01 = 135;
const int  roseQv00 = 225;
const int  roseQv10 = 315;
const int  roseQv11 =  45;
const int  roseQv01 = 135;

const int  roseQvR  =   0; // 
const int  roseQvUp =  90; // 
const int  roseQvL  = 180; // 
const int  roseQvDn = 270; // 




class t_Sprr1
{
private:
	//float mdmx[16]; // GL_MODELVIEW_MATRIX
	vec3 kx;
	vec3 ky;
	vec3 kz;

	vec3 r360[361]; // 0,,360

float Sprr1COS[361];//0,,360
float Sprr1SIN[361];



	void Sprr1FillCosSin()
	{
		float rad = 0.01745f; //   
		float ugRad = 0.f;

		for( int i=0; i < 361; i++)
		{
			Sprr1COS[i] = cosf( ugRad);
			Sprr1SIN[i] = sinf( ugRad);
			ugRad += rad;
		}
	}




	inline vec3 MultV( vec3 v) { return vec3( dot(kx, v),   dot(ky, v),   dot(kz, v)); }

	void UpdR360()
	{
		static int first=1;   if(first) { first=0; Sprr1FillCosSin(); }

		for( int i=0; i < 361; i++)
		{
			//r360[i] = MultV( vec3( cosf( ugRad), sinf( ugRad), 0.f) );
			r360[i] = MultV( vec3( Sprr1COS[i], Sprr1SIN[i], 0.f) );
		}

	}



public:
	t_Sprr1() {}

	void UpdMatrix()
	{
		//     ,   
		//          .

		float mdmx[16];  //double mdmx[16];
		glGetFloatv( GL_MODELVIEW_MATRIX, mdmx ); //glGetDoublev

		kx = vec3( mdmx[0], mdmx[1], mdmx[2]); // 3 
		ky = vec3( mdmx[4], mdmx[5], mdmx[6]); // 7 
		kz = vec3( mdmx[8], mdmx[9], mdmx[10]);

		UpdR360();
	}


	//  0,,360 (0 same 360)  // X on Goriz;  Y on Vertik;
	float Sin( int gra)
	{					if(gra < 0 || gra > 360) return Sprr1SIN[ 0];
		return Sprr1SIN[ gra];
	}
	float Sin( int gra, float mnoj)
	{					if(gra < 0 || gra > 360) return Sprr1SIN[ 0];
		return Sprr1SIN[ gra] * mnoj;
	}


	//  0,,360 (0 same 360)  // like Z always
	float Cos( int gra)
	{					if(gra < 0 || gra > 360) return Sprr1COS[ 0];
		return Sprr1COS[ gra];
	}
	float Cos( int gra, float mnoj)
	{					if(gra < 0 || gra > 360) return Sprr1COS[ 0];
		return Sprr1COS[ gra] * mnoj;
	}


	vec3 v3xzF( float graFlo, float mnoj)
	{					//if(gra < 0 || gra > 360) return vec3(0,0,1);
		return vec3( sinf(UgDTR(graFlo)), 0.f, cosf(UgDTR(graFlo))) * mnoj;
	}

	vec3 v3xz( int gra, float mnoj)
	{					if(gra < 0 || gra > 360) return vec3(0,0,1);
		return vec3( Sprr1SIN[ gra], 0.f, Sprr1COS[ gra]) * mnoj;
	}


	vec3 v( int gra)
	{					if(gra < 0 || gra > 360) return r360[ 0];
		return r360[ gra];
	}

	vec3 v( int gra, float mnoj)
	{					if(gra < 0 || gra > 360) return r360[ 0];
		return r360[ gra] * mnoj;
	}

	vec3 pos( int gra, float mnoj, vec3 Pos)
	{					if(gra < 0 || gra > 360) return Pos;
		return Pos + (r360[ gra] * mnoj);
	}

	vec3 vq00(float mnoj){	return r360[ roseQv00] * mnoj;}
	vec3 vq10(float mnoj){	return r360[ roseQv10] * mnoj;}
	vec3 vq11(float mnoj){	return r360[ roseQv11] * mnoj;}
	vec3 vq01(float mnoj){	return r360[ roseQv01] * mnoj;}

	vec3 pq00( float mnoj, vec3 Pos){	return Pos + (r360[ roseQv00] * mnoj);}
	vec3 pq10( float mnoj, vec3 Pos){	return Pos + (r360[ roseQv10] * mnoj);}
	vec3 pq11( float mnoj, vec3 Pos){	return Pos + (r360[ roseQv11] * mnoj);}
	vec3 pq01( float mnoj, vec3 Pos){	return Pos + (r360[ roseQv01] * mnoj);}

};


t_Sprr1  rose;











//	gluLookAt( ViewFrom[0],  ViewFrom[1], ViewFrom[2],
//		       ViewTo[0],   ViewTo[1],   ViewTo[2],
//			   UpVec[0],  UpVec[1],    UpVec[2] );
//  // ---
//	rose.UpdMatrix(); //      .





void DrawRoseR360()
{
	vec3 tmp;
	vec3 posc = vec3( 0.f, -5.f, -15.f);

	glBegin(GL_LINES); //  -
	for(int i=0; i < 361; i++)
	{
		if(i==0) tmp = rose.v(i, 5.f);
		else if(i==90) tmp = rose.v(i, 2.f);
		else tmp = rose.v(i, 1.f);

		glColor3f(0,0,0);
		glVertex3f( 0.f, 0.f, 0.f);

		glColor3f( float(i) / 360.f, 0.5f, 0.2f);
		glVertex3f( 0.f + tmp.x, 0.f + tmp.y, 0.f + tmp.z);
	}
	glEnd();


	glColor3f(1,1,1);
	glBegin(GL_QUADS); // -   

			tmp = rose.pq00(5.f, posc);
				glVertex3f( tmp.x,  tmp.y,  tmp.z);

			tmp = rose.pq10(5.f, posc);
				glVertex3f( tmp.x,  tmp.y,  tmp.z);

			tmp = rose.pq11(5.f, posc);
				glVertex3fv( &tmp.x);

			tmp = rose.pq01(5.f, posc);
				glVertex3fv( &tmp.x);
	glEnd();

}


































// ---------------



	void t_MeshAnk::TryGenUseMesh()
	{
		return;
		// ---
		//     .
		//    
		// (     ).

		// ---
		//    ..
		//rism.dip( int iKlv, UINT* pInd, vec3* pV,
		//	vec3* pN =0, BYTE* pRGBA =0, vec2* pUV =0, vec2* pUV2 =0 );

	}






// ----------

	int Mesh1_rec::SetRStates()
	{
		//    -  "  "

		if(tcase > 999) tcase % 1000;
		//SetShader( tcase);

	//	if(! tex1) pix1.off();
	//	else //{pix1.use( tex1); OGL::TexClamp();} //OGL::TexRepeat();
	//	pix1.use( tex1);


		//           .

		return 1;
	}











// --- public tz_Mesh..





	int tz_Mesh::Add( int decalGate, Fgr* pFgr,
		int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{

		if(m1Now >= tz_Mesh_m1Last) return 0;

		int i = rism.Kam_DecalMode();
		if( i )
		{ //   - //  decalGate   DecalMode,    
			if(i != decalGate) return 0;
		}
		else // .
		{ //   " " ,     .
			if(decalGate) return 0;
		}

		int staZ = staVersGet();
		//if( staZ < 0) return 0; // -1  - .

		// staZ klvZ    ,  - " ".
		//             
		// staZ    ,  klvZ  ,    ...
		//       Run,    
		//   ..  staVersSet, staVersGet, klvVersAdv.


		m1Now += 1;

		pRecAddNow = &( m1[ m1Now] ); //    AddPr & AddFree

pRecAddNow->texDifr = difTex; //  "  "
		pRecAddNow->tcase = tCase;
		pRecAddNow->tex1 = Tex1;
		pRecAddNow->tex2 = Tex2;
		pRecAddNow->pF   = pFgr;
		pRecAddNow->inFgr = NomZkzInFgr;



		if( staZ)
		{ // staZ          .
			// ,      staZ   .

			for(  i = staZ; i <= tz_Mesh_m2Last; i++) //   
			{	if( m2[ i] != 0) //  
				{
					if( Same1( m2[ i],  tCase, Tex1, Tex2, difTex) )
						{ Adv( i, m1Now);  return 1; }
				}
			}
			for( i = staZ; i <= tz_Mesh_m2Last; i++)
			{	if( m2[ i] == 0)
				{
					klvVersAdv(); //    
					Adv( i, m1Now);  return 1;
				}
			}
		}
		else //   Add    
		{
			for( i = 1; i <= tz_Mesh_m2Last; i++) //  
			{	if( m2[ i] == 0) //  
				{
					staVersSet(i);//       Add
					klvVersAdv(); // = 0 + 1;
					Adv( i, m1Now);  return 1;
				}
			}
		}

	return 0;
	}





	int tz_Mesh::AddFree( int decalGate, t_MeshAnk* pAnketa,
			int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{
		if( ! pAnketa) return 0;
		if( ! Add( decalGate, NULL, NomZkzInFgr, tCase, Tex1, Tex2, difTex) ) return 0;

		if( pRecAddNow) {pRecAddNow->pAnk = pAnketa;  pRecAddNow = 0;}
		return 1;
	}



	int tz_Mesh::AddPr( int decalGate,  void (*pProcSetMesh)(int),
			int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{
		if( ! pProcSetMesh) return 0;
		if( ! Add( decalGate, NULL, NomZkzInFgr, tCase, Tex1, Tex2, difTex) ) return 0;

		if( pRecAddNow) {pRecAddNow->pProcSetM = pProcSetMesh;  pRecAddNow = 0;}
		return 1;
	}







	void tz_Mesh::Run( int staZ, int klvZ)
	{
		if(staZ < 1) return;
		if(klvZ < 1) return;
		klvZ = staZ + klvZ; // klvZ   

		Mesh1_rec* r1 = NULL;

		int i;
		for( i = staZ; i < klvZ; i++) //   
		{
			if( i > tz_Mesh_m2Last) break;
			if( ! m2[ i] ) break;
			r1 = m2[ i]; //   .
				//,    "   ",
				//       .
				//       , 
				//    .
				//    ,   ,
				//       , 
				//    1000 // .Mesh.Add( ... tCase * 1000 ...);

			r1->SetRStates();
				//,  "    "   
				//      glDrawElements()

			while( r1 ) //   --
			{
				if( r1->tex1) pix1.use( r1->tex1); else pix1.off();

				//    ""..
					//     ,     
					//   -   ( - 
					//  ,    ) ...
					//  -    rism.dip(...)
				if( ! r1->pF) //   
				{
					if( r1->pProcSetM) r1->pProcSetM( r1->inFgr );
					else if(r1->pAnk) r1->pAnk->TryGenUseMesh();
				}
				else // "- "  - ..
				{
					r1->pF->OnR_inFgr = r1->inFgr;
					r1->pF->TryOnRender(); //      OnR_inFgr
				}

				r1 = r1->next;
			}

		}
		//for

		OGL::KlientVertexOFF();
		OGL::KlientNrmOFF();
		OGL::KlientColorOFF();
		OGL::KlientTexC_OFF(0);

	}
	// Run





/* Fgr::TryOnRender  ..

	//     .
	//     //   .
	//           .

	glPushMatrix(); //{

		this->bs.MxTransOGL(); //     .
		SvetStdForFgr( &this->SveOkr ); //    .
		Material_Arg( &this->MatDetails );

		glPushMatrix(); //{   - , , ..
			glTranslatef( 0.f, 1.f, 0.f); //    .
			this->bs.MxRotOGL();       //     .
			glScalef(2.f, 2.f, 2.f); //    .

				rism.dip( this->myMesh ); //   // glDrawElements
		glPopMatrix(); //}

		glPushMatrix(); //{       ..
			glTranslatef( 0.f, 4.f, 0.f);
			glRotatef( dyn_ang, 1,0,0);  //dyn_ang    .

				rism.dip( this->indKlv_Ring, this->pInd_Ring, 0);
					//      (- ).
					// ---
					// -   ,     
					//    _Ring     .
					//         .
		glPopMatrix(); //}

	glPopMatrix(); //}
*/







































// @@MSpr

//     " "   .
//           .
//   ,   .


const WORD MSpr_LastVert = tz_Quad_m1Last * 4;
//WORD     " "


class tMSpr
{
private:

int TekV;
int Tek2D;


vec2  Vert2D[ MSpr_LastVert+1];

vec3  Vert[ MSpr_LastVert+1];
vec4  fRGBA[ MSpr_LastVert+1];
vec2   UV1[  MSpr_LastVert+1];
//vec2  UV2[ MSpr_LastVert+1];



//    -      ,   
//   -    .
//    ,   .
int NextQuad_Non()
{
	if( (TekV + 3) > MSpr_LastVert) return 1;  return 0;
}


// priv
void privSetV( int ofsV, float vx, float vy, float vz=0.f)
{

		if(Tek2D)
			Vert2D[ofsV] = vec2( vx, vy);
		else Vert[ofsV] = vec3( vx, vy, vz);

}

// priv
void privSetClr( int ofsV, float R=1.f, float G=1.f, float B=1.f, float A=1.f)
{
		fRGBA[ofsV] = vec4(R, G, B, A);
}

// priv
void privSetUV1( int ofsV, float U, float V)
{
		UV1[ofsV] = vec2( U, V);
}
// priv
//void privSetUV2( int ofsV, float U, float V)
//{
//		UV2[ofsV] = vec2( U, V);
//}



//priv
void privSetQV0( float* f3_4, vec3& cP, float& diaHf)
{
	vec3 di = rose.pq00( diaHf, cP);
	f3_4[0] = di.x;   f3_4[1] = di.y;   f3_4[2] = di.z;

		di = rose.pq10( diaHf, cP);
	f3_4[3] = di.x;   f3_4[4] = di.y;   f3_4[5] = di.z;

		di = rose.pq11( diaHf, cP);
	f3_4[6] = di.x;   f3_4[7] = di.y;   f3_4[8] = di.z;

		di = rose.pq01( diaHf, cP);
	f3_4[9] = di.x;   f3_4[10] = di.y;   f3_4[11] = di.z;
}
//priv
void privSetQV1( float* f3_4, vec3& cP, float& diaHf, int& rotUg, int ForLowDia=0)
{
	//	rotUg = zn::Ring1i( rotUg, 360);//    0,,360
					int ug = zn::Ring1i( roseQv00 + rotUg - ForLowDia, 360);
	vec3 di = rose.pos( ug, diaHf, cP);
	f3_4[0]= di.x;
	f3_4[1]= di.y;
	f3_4[2]= di.z;
						ug = zn::Ring1i( roseQv10 + rotUg + ForLowDia, 360);
		di = rose.pos( ug, diaHf, cP);
	f3_4[3]= di.x;
	f3_4[4]= di.y;
	f3_4[5]= di.z;
						ug = zn::Ring1i( roseQv11 + rotUg, 360);
		di = rose.pos( ug, diaHf, cP);
	f3_4[6]= di.x;
	f3_4[7]= di.y;
	f3_4[8]= di.z;
						ug = zn::Ring1i( roseQv01 + rotUg, 360);
		di = rose.pos( ug, diaHf, cP);
	f3_4[9]= di.x;
	f3_4[10]= di.y;
	f3_4[11]= di.z;
}



//priv
void privSetQVRay0( float* f3_4, vec3& cP, vec3& cP2, float& LenHUp)
{
	//      (+-45  ) (   -)
	//      4  2 

	//   ,     .
	//     
	f3_4[0] = cP.x;    f3_4[1] = cP.y + LenHUp;    f3_4[2]=cP.z;
	f3_4[3] = cP.x;    f3_4[4] = cP.y - LenHUp;    f3_4[5]=cP.z;
	f3_4[6] = cP2.x;   f3_4[7] = cP2.y - LenHUp;   f3_4[8]=cP2.z;
	f3_4[9] = cP2.x;   f3_4[10]= cP2.y + LenHUp;   f3_4[11]=cP2.z;

		//   ..
//	f3_4[0]=cP.x;		f3_4[1]=cP.y - LenHUp;		f3_4[2]=cP.z;
//	f3_4[3]=cP2.x;		f3_4[4]=cP2.y - LenHUp;		f3_4[5]=cP2.z;
//	f3_4[6]=cP2.x;		f3_4[7]=cP2.y + LenHUp;		f3_4[8]=cP2.z;
//	f3_4[9]=cP.x;		f3_4[10]=cP.y + LenHUp;		f3_4[11]=cP.z;
}
//priv
void privSetQVRay1( float* f3_4, vec3& cP, vec3& cP2, vec3& di, int DifEdge=0, float DifEdgeMul=2.f)
{
	//      cP //     cP
	f3_4[0]=cP.x + di.x;		f3_4[1]=cP.y + di.y;		f3_4[2]=cP.z + di.z;
	f3_4[3]=cP.x - di.x;		f3_4[4]=cP.y - di.y;		f3_4[5]=cP.z - di.z;
		//
	if(DifEdge) di = di * DifEdgeMul;
	f3_4[6]=cP2.x - di.x;		f3_4[7]=cP2.y - di.y;		f3_4[8]=cP2.z - di.z;
	f3_4[9]=cP2.x + di.x;		f3_4[10]=cP2.y + di.y;		f3_4[11]=cP2.z + di.z;
}
// priv
void privSetQVRayY( float* f3_4, vec3& cP, vec3& cP2, float& LenHW)
{
	//    "",     10   
	//  - .
	//    "  ",  - .
	//     "-" .

	//if( zn::Absi(cP.z - cP2.z) > zn::Absi(cP.x - cP2.x) )
	if( zn::Absf(cP.z - cP2.z) > zn::Absf(cP.x - cP2.x) )
	{
	f3_4[0]=cP.x - LenHW;		f3_4[1]=cP.y;		f3_4[2]=cP.z;
	f3_4[3]=cP.x + LenHW;		f3_4[4]=cP.y;		f3_4[5]=cP.z;

	f3_4[6]=cP2.x + LenHW;		f3_4[7]=cP2.y;		f3_4[8]=cP2.z;
	f3_4[9]=cP2.x - LenHW;		f3_4[10]=cP2.y;		f3_4[11]=cP2.z;
	return;
	}
	f3_4[0]=cP.x;		f3_4[1]=cP.y;		f3_4[2]=cP.z - LenHW;
	f3_4[3]=cP.x;		f3_4[4]=cP.y;		f3_4[5]=cP.z + LenHW;

	f3_4[6]=cP2.x;		f3_4[7]=cP2.y;		f3_4[8]=cP2.z + LenHW;
	f3_4[9]=cP2.x;		f3_4[10]=cP2.y;		f3_4[11]=cP2.z - LenHW;

}















public:

	friend class Quads1_rec;
	friend class tz_Quad;

	tMSpr()
	{
		TekV = 0;
		Tek2D = 0;
	}








	//  2D      //   q2DVS
float* q2DV( float* f3_4, float cPX, float cPY, float diaHf, int rotUg)
{
	if( ! f3_4) return 0;
	int ug;

	ug = zn::Ring1i( roseQv00 + rotUg, 360);
  		f3_4[0] = cPX + rose.Cos(ug, diaHf);
		f3_4[1] = cPY + rose.Sin(ug, diaHf);		f3_4[2]=0.f;

	ug = zn::Ring1i( roseQv10 + rotUg, 360);
		f3_4[3] = cPX + rose.Cos(ug, diaHf);
		f3_4[4] = cPY + rose.Sin(ug, diaHf);		f3_4[5]=0.f;

	ug = zn::Ring1i( roseQv11 + rotUg, 360);
		f3_4[6] = cPX + rose.Cos(ug, diaHf);
		f3_4[7] = cPY + rose.Sin(ug, diaHf);		f3_4[8]=0.f;

	ug = zn::Ring1i( roseQv01 + rotUg, 360);
		f3_4[9] = cPX + rose.Cos(ug, diaHf);
		f3_4[10] =cPY + rose.Sin(ug, diaHf);		f3_4[11]=0.f;

	return f3_4;
}

	//  2D      //   q2DVS
float* q2DVhf( float* f3_4, float cPX, float cPY, float hafEdge, int rotUg)
{
	if( ! f3_4) return 0;
	int ug;

	float d = hafEdge / 0.707f; //  45

	ug = zn::Ring1i( roseQv00 + rotUg, 360);
  		f3_4[0] = cPX + rose.Cos(ug, d);
		f3_4[1] = cPY + rose.Sin(ug, d);		f3_4[2]=0.f;

	ug = zn::Ring1i( roseQv10 + rotUg, 360);
		f3_4[3] = cPX + rose.Cos(ug, d);
		f3_4[4] = cPY + rose.Sin(ug, d);		f3_4[5]=0.f;

	ug = zn::Ring1i( roseQv11 + rotUg, 360);
		f3_4[6] = cPX + rose.Cos(ug, d);
		f3_4[7] = cPY + rose.Sin(ug, d);		f3_4[8]=0.f;

	ug = zn::Ring1i( roseQv01 + rotUg, 360);
		f3_4[9] = cPX + rose.Cos(ug, d);
		f3_4[10] =cPY + rose.Sin(ug, d);		f3_4[11]=0.f;

	return f3_4;
}





float* q2DVS( float* f3_4, float cPX, float cPY, float hafEdge)
{
	if( ! f3_4) return 0;
	f3_4[0]=cPX - hafEdge;		f3_4[1]=cPY - hafEdge;		f3_4[2]=0.f;
	f3_4[3]=cPX + hafEdge;		f3_4[4]=cPY - hafEdge;		f3_4[5]=0.f;
	f3_4[6]=cPX + hafEdge;		f3_4[7]=cPY + hafEdge;		f3_4[8]=0.f;
	f3_4[9]=cPX - hafEdge;		f3_4[10]=cPY + hafEdge;		f3_4[11]=0.f;
	return f3_4;
}

	// float hafEdge // 2D      ()
	// x y w h //       
float* q2DVS( float* f3_4, int x, int y, int w, int h)
{
	if( ! f3_4) return 0;

	float hafW = w/2;
	float hafH = h/2;
	float cPX = x + hafW;
	float cPY = y + hafH;

	f3_4[0]=cPX - hafW;		f3_4[1]=cPY - hafH;		f3_4[2]=0.f;
	f3_4[3]=cPX + hafW;		f3_4[4]=cPY - hafH;		f3_4[5]=0.f;
	f3_4[6]=cPX + hafW;		f3_4[7]=cPY + hafH;		f3_4[8]=0.f;
	f3_4[9]=cPX - hafW;		f3_4[10]=cPY + hafH;	f3_4[11]=0.f;
	return f3_4;
}






// ----------
//       .
//       ""      .
//           
//    -    ,     ( 
//        )
//      -  ,   "".

//      -  -.
//     ,  Prov= 40
//     ,  Prov= 20
//	ug = zn::Ring1i( roseQv00 + rotUg - Prov, 360);	//di = rose.v( ug, diaHf);  ...
//	ug = zn::Ring1i( roseQv10 + rotUg + Prov, 360);	// ...
//     .
//     int ForLowDia   qV
//       ...
//       ..
// _qVRot    ,    .
// _qVLow ,   "  -"   .

//     ForLowDia //     _qVLow
//  ,    . //    _qVRot
float* qV( float* f3_4, vec3 cP, float diaHf, int rotUg=0)
{
	if( ! f3_4) return 0;

	if(rotUg == 0 || rotUg == 360)
			privSetQV0( f3_4, cP, diaHf);
	else  privSetQV1( f3_4, cP, diaHf, rotUg);

	return f3_4;
}

// rotUg=       (  ., 3   )
float* qVRot( float* f3_4, vec3 cP, float diaHf, int rotUg)
{
	if( ! f3_4) return 0;
	privSetQV1( f3_4, cP, diaHf, rotUg);	return f3_4;
}

float* qVLow( float* f3_4, vec3 cP, float diaHf, int ForLowDia)
{
	if( ! f3_4) return 0;
	int rotUg=0;	zn::Abs( ForLowDia); //if( ForLowDia < 0) ForLowDia = -ForLowDia;

	privSetQV1( f3_4, cP, diaHf, rotUg, ForLowDia);	return f3_4;
}


	//        -.
	// LenMain= - (  -   ).
	// LenHafW=   -    . // modeW as 0
	// rotUg=  -   (  ., 3   )
	// rotUg  .
	//  modeW as 1, then LenHafW  - 
	//  modeW as 2, then LenHafW     modeW2  .
	// qRayV //    
float* qVRay( float* f3_4, vec3 cP, float LenMain, float LenHafW, int rotUg,
				  int modeW=0, float modeW2=2.f)
{
	if( ! f3_4) return 0;
	int ug = zn::Ring1i( rotUg, 360);
	vec3 cP2 = cP + rose.v( ug, LenMain); //    -

	if(modeW !=1)
	{
								ug = zn::Ring1i( rotUg + 90, 360);
		vec3 di = rose.v( ug, LenHafW); //    

		if(modeW==0)		privSetQVRay1( f3_4, cP, cP2, di);
		else if(modeW==2)	privSetQVRay1( f3_4, cP, cP2, di, modeW, modeW2);
	}
	else privSetQVRay0( f3_4, cP, cP2, LenHafW);

return f3_4;
}


/*  // ,         
float* qVRay2( float* f3_4, vec3 cP, vec3 cP2, float LenHafW, int modeW=0, float modeW2=2.f)
{
	if( ! f3_4) return 0;

	if(modeW !=1)
	{
		//      ...
		//     - 
		int ekX1, ekY1, ekX2, ekY2, ug=90;
		if( GetPointToEkran( cP, ekX1, ekY1, glob_nowVPKam)
			&&GetPointToEkran( cP2, ekX2, ekY2, glob_nowVPKam) )
		{
												// ,   
			ug = zn::Ring1i( UgFromVecPart( ekY2 - ekY1, ekX2 - ekX1) + 90, 360);
		}

						//ug = zn::Ring1i( AngleMej2V( cP2 - cP, rose.v(0) ) + 90, 360);
		vec3 di = rose.v( ug ) * LenHafW; //    

		if(modeW==0)		privSetQVRay1( f3_4, cP, cP2, di);
		else if(modeW==2)	privSetQVRay1( f3_4, cP, cP2, di, modeW, modeW2);
	}
	else
		privSetQVRay0( f3_4, cP, cP2, LenHafW);

return f3_4;
}
*/


	//   . mode=0  -   . mode=1  
float* qVRay2( float* f3_4, vec3 cP, vec3 cP2, float LenHafW, int mode=0)
{
	if( ! f3_4) return 0;

	if(mode ==1)
			privSetQVRay0( f3_4, cP, cP2, LenHafW);
	else	privSetQVRayY( f3_4, cP, cP2, LenHafW);

return f3_4;
}



	// ,      - ...
	// cP     
	// 2008g  // LenUp   ,    
	//    (      )
float* qVKust( float* f3_4, vec3 cP, float LenHafW, float LenUp)
{
	if( ! f3_4) return 0;

	vec3 di = rose.v( roseQvL, LenHafW); //180

		f3_4[0]=cP.x + di.x;		f3_4[1]=cP.y;		f3_4[2]=cP.z + di.z;
		f3_4[3]=cP.x - di.x;		f3_4[4]=cP.y;		f3_4[5]=cP.z - di.z;
		f3_4[6]=cP.x - di.x;		f3_4[7]=cP.y+ LenUp;		f3_4[8]=cP.z - di.z;
		f3_4[9]=cP.x + di.x;		f3_4[10]=cP.y+ LenUp;		f3_4[11]=cP.z + di.z;

return f3_4;
}




	//   (-       )
	//    glDisable(GL_CULL_FACE);
float* qVAxX( float* f3_4, vec3 cP, float LenHW, float LenHY)
{
if( ! f3_4) return 0;
	f3_4[0]=cP.x;		f3_4[1]=cP.y - LenHY;		f3_4[2]=cP.z + LenHW;
	f3_4[3]=cP.x;		f3_4[4]=cP.y - LenHY;		f3_4[5]=cP.z - LenHW;
	f3_4[6]=cP.x;		f3_4[7]=cP.y+ LenHY;		f3_4[8]=cP.z - LenHW;
	f3_4[9]=cP.x;		f3_4[10]=cP.y+ LenHY;		f3_4[11]=cP.z + LenHW;
return f3_4;
}

float* qVAxZ( float* f3_4, vec3 cP, float LenHW, float LenHY)
{
if( ! f3_4) return 0;
	f3_4[0]=cP.x - LenHW;		f3_4[1]=cP.y - LenHY;		f3_4[2]=cP.z;
	f3_4[3]=cP.x + LenHW;		f3_4[4]=cP.y - LenHY;		f3_4[5]=cP.z;
	f3_4[6]=cP.x + LenHW;		f3_4[7]=cP.y+ LenHY;		f3_4[8]=cP.z;
	f3_4[9]=cP.x - LenHW;		f3_4[10]=cP.y+ LenHY;		f3_4[11]=cP.z;
return f3_4;
}

	//    ,      
float* qVAxY( float* f3_4, vec3 cP, float LenHW, float LenHZ)
{
if( ! f3_4) return 0;
	f3_4[0]=cP.x - LenHW;		f3_4[1]=cP.y;		f3_4[2]=cP.z + LenHZ;
	f3_4[3]=cP.x + LenHW;		f3_4[4]=cP.y;		f3_4[5]=cP.z + LenHZ;
	f3_4[6]=cP.x + LenHW;		f3_4[7]=cP.y;		f3_4[8]=cP.z - LenHZ;
	f3_4[9]=cP.x - LenHW;		f3_4[10]=cP.y;		f3_4[11]=cP.z - LenHZ;
return f3_4;
}







	//       
float* qVAxXR( float* f3_4, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45)
{
if( ! f3_4) return 0;  zn::Abs(ot0Ug); zn::Abs(ot180Ug);

	int ug = zn::Ring1i( mainRotUg + 180 + ot180Ug, 360);
	f3_4[0] = cP.x;
	f3_4[1] = cP.y + rose.Sin(ug, diaHf);
	f3_4[2] = cP.z + rose.Cos(ug, diaHf);

	ug = zn::Ring1i( mainRotUg - ot0Ug, 360);
	f3_4[3] = cP.x;
	f3_4[4] = cP.y + rose.Sin(ug, diaHf);
	f3_4[5] = cP.z + rose.Cos(ug, diaHf);

	ug = zn::Ring1i( mainRotUg + ot0Ug, 360);
	f3_4[6] = cP.x;
	f3_4[7] = cP.y + rose.Sin(ug, diaHf);
	f3_4[8] = cP.z + rose.Cos(ug, diaHf);

	ug = zn::Ring1i( mainRotUg + 180 - ot180Ug, 360);
	f3_4[9] = cP.x;
	f3_4[10] =cP.y+ rose.Sin(ug, diaHf);
	f3_4[11] =cP.z+ rose.Cos(ug, diaHf);

return f3_4;
}
	//     
float* qVAxZR( float* f3_4, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45 )
{
if( ! f3_4) return 0;  zn::Abs(ot0Ug); zn::Abs(ot180Ug);

	int ug = zn::Ring1i( mainRotUg + 180 + ot180Ug, 360);
	f3_4[0] = cP.x + rose.Cos(ug, diaHf);
	f3_4[1] = cP.y + rose.Sin(ug, diaHf);
	f3_4[2] = cP.z;

	ug = zn::Ring1i( mainRotUg - ot0Ug, 360);
	f3_4[3] = cP.x + rose.Cos(ug, diaHf);
	f3_4[4] = cP.y + rose.Sin(ug, diaHf);
	f3_4[5] = cP.z;

	ug = zn::Ring1i( mainRotUg + ot0Ug, 360);
	f3_4[6] = cP.x + rose.Cos(ug, diaHf);
	f3_4[7] = cP.y + rose.Sin(ug, diaHf);
	f3_4[8] = cP.z;

	ug = zn::Ring1i( mainRotUg + 180 - ot180Ug, 360);
	f3_4[9] = cP.x + rose.Cos(ug, diaHf);
	f3_4[10] =cP.y + rose.Sin(ug, diaHf);
	f3_4[11] =cP.z;
return f3_4;
}

	//    ,      
	//          90   
float* qVAxYR( float* f3_4, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45 )
{
if( ! f3_4) return 0;  zn::Abs(ot0Ug); zn::Abs(ot180Ug);

	int ug = zn::Ring1i( mainRotUg + 180 + ot180Ug, 360);
	f3_4[0] = cP.x + rose.Cos(ug, diaHf);
	f3_4[1] = cP.y;
	f3_4[2] = cP.z + rose.Sin(ug, diaHf);

	ug = zn::Ring1i( mainRotUg - ot0Ug, 360);
	f3_4[3] = cP.x + rose.Cos(ug, diaHf);
	f3_4[4] = cP.y;
	f3_4[5] = cP.z + rose.Sin(ug, diaHf);

	ug = zn::Ring1i( mainRotUg + ot0Ug, 360);
	f3_4[6] = cP.x + rose.Cos(ug, diaHf);
	f3_4[7] = cP.y;
	f3_4[8] = cP.z + rose.Sin(ug, diaHf);

	ug = zn::Ring1i( mainRotUg + 180 - ot180Ug, 360);
	f3_4[9] = cP.x + rose.Cos(ug, diaHf);
	f3_4[10] =cP.y;
	f3_4[11] =cP.z + rose.Sin(ug, diaHf);
return f3_4;
}











float* qClr( float* fClr4_4, float CR, float CG, float CB, float CA=0.5f)
{
	fClr4_4[0] = CR;  fClr4_4[1] = CG;  fClr4_4[2] = CB;  fClr4_4[3] = CA;
	fClr4_4[4] = CR;  fClr4_4[5] = CG;  fClr4_4[6] = CB;  fClr4_4[7] = CA;
	fClr4_4[8] = CR;  fClr4_4[9] = CG;  fClr4_4[10] = CB;  fClr4_4[11] = CA;
	fClr4_4[12] = CR;  fClr4_4[13] = CG;  fClr4_4[14] = CB;  fClr4_4[15] = CA;

	return fClr4_4;
}

float* qClrB( float* fClr4_4, BYTE cr1, BYTE cg1, BYTE cb1, BYTE ca1 = 127)
{
	float CR = float(cr1) / 255.f;
	float CG = float(cg1) / 255.f;
	float CB = float(cb1) / 255.f;
	float CA = float(ca1) / 255.f;
	fClr4_4[0] = CR;  fClr4_4[1] = CG;  fClr4_4[2] = CB;  fClr4_4[3] = CA;
	fClr4_4[4] = CR;  fClr4_4[5] = CG;  fClr4_4[6] = CB;  fClr4_4[7] = CA;
	fClr4_4[8] = CR;  fClr4_4[9] = CG;  fClr4_4[10] = CB;  fClr4_4[11] = CA;
	fClr4_4[12] = CR;  fClr4_4[13] = CG;  fClr4_4[14] = CB;  fClr4_4[15] = CA;

	return fClr4_4;
}

	// xMode  16  16     -    ,   .
float* qClrX( float* fClr4_4, int xMode, float* x8)
{
	if( ! x8) return NULL;

	if(xMode == 16) return x8;
		// AnProc( qClrX( w0qc, clr16, cm) );
		// AnProc( (clr16 == 16)? cm : qClrX( w0qc, clr16, cm) );

	if(xMode == 1)
	{
		fClr4_4[0] = x8[0];  fClr4_4[1] = x8[0];  fClr4_4[2] = x8[0];  fClr4_4[3] = x8[0];
		fClr4_4[4] = x8[0];  fClr4_4[5] = x8[0];  fClr4_4[6] = x8[0];  fClr4_4[7] = x8[0];
		fClr4_4[8] = x8[0];  fClr4_4[9] = x8[0];  fClr4_4[10] = x8[0];  fClr4_4[11] = x8[0];
		fClr4_4[12] = x8[0];  fClr4_4[13] = x8[0];  fClr4_4[14] = x8[0];  fClr4_4[15] = x8[0];
	}
	else if(xMode == 2)//  + 
	{
		return qClr( fClr4_4, x8[0], x8[0], x8[0], x8[1]);
	}
	else if(xMode == 3)//  + 1
	{
		return qClr( fClr4_4, x8[0], x8[1], x8[2], 1.f);
	}
	else if(xMode == 4)// -
	{
		return qClr( fClr4_4, x8[0], x8[1], x8[2], x8[3]);
	}
	else if(xMode == 8)//     + 
	{
		fClr4_4[0] =  x8[0];  fClr4_4[1] =  x8[0];  fClr4_4[2] =  x8[0];  fClr4_4[3] =  x8[1];
		fClr4_4[4] =  x8[2];  fClr4_4[5] =  x8[2];  fClr4_4[6] =  x8[2];  fClr4_4[7] =  x8[3];
		fClr4_4[8] =  x8[4];  fClr4_4[9] =  x8[4];  fClr4_4[10] = x8[4];  fClr4_4[11] = x8[5];
		fClr4_4[12] = x8[6];  fClr4_4[13] = x8[6];  fClr4_4[14] = x8[6];  fClr4_4[15] = x8[7];
	}
	else return NULL;

	return fClr4_4;
}


	// cln =   .
	// etaj =   .
float* qTC( float* fTC2_4,  int clnFr1, int clnKlv,  int etajFr1, int etajKlv, int gorizMirr =0)
{
	if( ! fTC2_4) return 0;
	if( clnKlv < 1) return 0;
	if( etajKlv < 1) return 0;

	if(clnKlv==1 && etajKlv==1)
	{
		if(gorizMirr)
		{
			fTC2_4[0]= 1.0f;  fTC2_4[1]= 0.0f;
			fTC2_4[2]= 0.0f;  fTC2_4[3]= 0.0f;

			fTC2_4[4]= 0.0f;  fTC2_4[5]= 1.0f;
			fTC2_4[6]= 1.0f;  fTC2_4[7]= 1.0f;
		}
		else
		{
			fTC2_4[0]= 0.0f;  fTC2_4[1]= 0.0f;
			fTC2_4[2]= 1.0f;  fTC2_4[3]= 0.0f;
			fTC2_4[4]= 1.0f;  fTC2_4[5]= 1.0f;
			fTC2_4[6]= 0.0f;  fTC2_4[7]= 1.0f;
		}
		return fTC2_4;
	}

	float TP, TPV;
	float TOffset= clnFr1 - 1;
	float TOffsetY= etajFr1 - 1;

	switch( clnKlv)
	{
	case 1: TP = 1.0f; break;
	case 2: TP = 0.5f; break;
	case 3: TP = 0.3333f; break;
	case 4: TP = 0.25f; break;
	case 5: TP = 0.2f; break;
	case 6: TP = 0.1666f; break;
	case 7: TP = 0.1428f; break;
	case 8: TP = 0.125f; break;
	default: TP = FDI(1, clnKlv); break;
	}
	switch( etajKlv)
	{
	case 1: TPV = 1.0f; break;
	case 2: TPV = 0.5f; break;
	case 3: TPV = 0.3333f; break;
	case 4: TPV = 0.25f; break;
	case 5: TPV = 0.2f; break;
	case 6: TPV = 0.1666f; break;
	case 7: TPV = 0.1428f; break;
	case 8: TPV = 0.125f; break;
	default: TPV = FDI(1, etajKlv); break;
	}

	TOffset = TP * TOffset;
	TOffsetY = TPV * TOffsetY; //    ...

	if( gorizMirr)
	{
		fTC2_4[0]= TOffset + TP;  fTC2_4[1]= TOffsetY; // left
		fTC2_4[2]= TOffset;       fTC2_4[3]= TOffsetY; // rit

		fTC2_4[4]= TOffset;       fTC2_4[5]= TOffsetY + TPV; //rit
		fTC2_4[6]= TOffset + TP;  fTC2_4[7]= TOffsetY + TPV;//left
	}
	else
	{
		fTC2_4[0]= TOffset;			fTC2_4[1]= TOffsetY;
		fTC2_4[2]= TOffset + TP;  fTC2_4[3]= TOffsetY;
		fTC2_4[4]= TOffset + TP;  fTC2_4[5]= TOffsetY + TPV;
		fTC2_4[6]= TOffset;			fTC2_4[7]= TOffsetY + TPV;
	}

	return fTC2_4;
}



inline float* qTC( float* fTC2_4,  int nomInLineFr1, int clnKlv, int etajKlv)
{
	return qTC( fTC2_4,
		nomInLineFr1 % clnKlv,  clnKlv,
		(nomInLineFr1-1)/etajKlv +1, etajKlv);
}




// ---------- main
//	float qv[12];
//	float qc[16] = {0.8f};
//	float qt[16];
//SetQuad( ProV( qv, anP, 5.f, 45),  qc,
//  ProUV( qt, 1,5,  2,5),
//  ProUV( &qt[8], 3,4, 1,4)  );
//
void SetQuad( float* f3_4, float* fClr4_4, float* fTC2_4=0, float* fDTC2_4=0)
{
	if(NextQuad_Non()) return;
	if( ! f3_4) return;
	//if( ! fTC2_4) return;
	//if( ! fClr4_4) return; //   

	privSetV( TekV, f3_4[0], f3_4[1], f3_4[2]);
	privSetV( TekV+1, f3_4[3], f3_4[4], f3_4[5]);
	privSetV( TekV+2, f3_4[6], f3_4[7], f3_4[8]);
	privSetV( TekV+3, f3_4[9], f3_4[10], f3_4[11]);

	if( ! fClr4_4)
	{
		privSetClr( TekV);
		privSetClr( TekV+1);
		privSetClr( TekV+2);
		privSetClr( TekV+3);
	}
	else
	{
		privSetClr( TekV, fClr4_4[0], fClr4_4[1], fClr4_4[2], fClr4_4[3]);
		privSetClr( TekV+1, fClr4_4[4], fClr4_4[5], fClr4_4[6], fClr4_4[7]);
		privSetClr( TekV+2, fClr4_4[8], fClr4_4[9], fClr4_4[10], fClr4_4[11]);
		privSetClr( TekV+3, fClr4_4[12], fClr4_4[13], fClr4_4[14], fClr4_4[15]);
	}

	if( fTC2_4)
	{
	privSetUV1( TekV, fTC2_4[0], fTC2_4[1]);
	privSetUV1( TekV+1, fTC2_4[2], fTC2_4[3]);
	privSetUV1( TekV+2, fTC2_4[4], fTC2_4[5]);
	privSetUV1( TekV+3, fTC2_4[6], fTC2_4[7]);
	}

	//if( fDTC2_4)
	//{
	//privSetUV2( TekV, fDTC2_4[0], fDTC2_4[1]);
	//privSetUV2( TekV+1, fDTC2_4[2], fDTC2_4[3]);
	//privSetUV2( TekV+2, fDTC2_4[4], fDTC2_4[5]);
	//privSetUV2( TekV+3, fDTC2_4[6], fDTC2_4[7]);
	//}

	//      ..
	TekV += 4;
}


/*
void AddQuad( vec3 cP, float diaHf, int rotUg, tile)
{
	rotUg = zn::Ring1i( rotUg, 360);//    0,,360
	vec3 di;

	if(rotUg == 0 || rotUg == 360)
	{
		di = rose.pq00( diaHf, cP);  privSetV( TekV,  di.x, di.y, di.z);
		di = rose.pq10( diaHf, cP);  privSetV( TekV+1,  di.x, di.y, di.z);
		di = rose.pq11( diaHf, cP);  privSetV( TekV+2,  di.x, di.y, di.z);
		di = rose.pq01( diaHf, cP);  privSetV( TekV+3,  di.x, di.y, di.z);
	}
	else
	{
	}

	TekV += 4;
}
*/






};
tMSpr  MSpr;





















//   t_SpriteAnk::TrySetQ
// SprMixSetQ( MSpr.q2DV( w0qv, 100, 300, 50.f, 20) );

/*
#define SprMixSetQ( mainVertCall) MSpr.SetQuad( mainVertCall ,\
	MSpr.qClrX( w0qc, clr16, cm),\
	MSpr.qTC( w0qt,  tc1k, tc2klv,   tc3e, tc4klv),\
	MSpr.qTC( &(w0qt[8]),  tc5k, tc6klv,   tc7e, tc8klv) )
*/

#define SprMixSetQ( mainVertCall) MSpr.SetQuad( mainVertCall ,\
	MSpr.qClrX( w0qc, clr16, cm),\
	MSpr.qTC( w0qt,  tc1k, tc2klv,   tc3e, tc4klv) )


void t_SpriteAnk::TrySetQ()
{
	if( ! VrtSetVers) return;

	switch( VrtSetVers)
	{
	case VrtSet_q2DV:
		SprMixSetQ( MSpr.q2DV( w0qv, pos1.x, pos1.y, f1_diaHf, f2_Rot) );
			//q2DV( w0qv, float cPX, float cPY, float diaHf, int rotUg)
		break;
	case VrtSet_q2DVhf:
		SprMixSetQ( MSpr.q2DVhf( w0qv, pos1.x, pos1.y, f1_diaHf, f2_Rot) ); //f1_diaHf as hafEdge
			//q2DVhf( w0qv, float cPX, float cPY, float hafEdge, int rotUg)
		break;
	case VrtSet_q2DVS:
		SprMixSetQ( MSpr.q2DVS( w0qv, pos1.x, pos1.y, f1_diaHf) );
			//q2DVS( w0qv, float cPX, float cPY, float hafEdge)
		break;
	case VrtSet_q2DVS_xywh:
		SprMixSetQ( MSpr.q2DVS( w0qv,  pos1.x, pos1.y ,  f1_diaHf, f2_Rot) ); //f2_Rot as h
			//q2DVS( w0qv, int x, int y, int w, int h)
		break;

	case VrtSet_qV:
		SprMixSetQ( MSpr.qV( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qV( w0qv, vec3 cP, float diaHf, int rotUg=0)
		break;
	case VrtSet_qVRot:
		SprMixSetQ( MSpr.qVRot( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVRot( w0qv, vec3 cP, float diaHf, int rotUg)
		break;
	case VrtSet_qVLow:
		SprMixSetQ( MSpr.qVLow( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVLow( w0qv, vec3 cP, float diaHf, int ForLowDia)
		break;

	case VrtSet_qVKust:
		SprMixSetQ( MSpr.qVKust( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVKust( w0qv, vec3 cP, float LenHafW, float LenUp)
		break;

	case VrtSet_qVAxX:
		SprMixSetQ( MSpr.qVAxX( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVAxX( w0qv, vec3 cP, float LenHW, float LenHY)
		break;
	case VrtSet_qVAxZ:
		SprMixSetQ( MSpr.qVAxZ( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVAxZ( w0qv, vec3 cP, float LenHW, float LenHY)
		break;
	case VrtSet_qVAxY:
		SprMixSetQ( MSpr.qVAxY( w0qv, pos1,  f1_diaHf, f2_Rot) );
			//qVAxY( w0qv, vec3 cP, float LenHW, float LenHZ)
		break;

	case VrtSet_qVAxXR:
		SprMixSetQ( MSpr.qVAxXR( w0qv, pos1,  f1_diaHf, f2_Rot,  uniV.x, uniV.y) );
			//qVAxXR( w0qv, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45)
		break;
	case VrtSet_qVAxZR:
		SprMixSetQ( MSpr.qVAxZR( w0qv, pos1,  f1_diaHf, f2_Rot,  uniV.x, uniV.y) );
			//qVAxZR( w0qv, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45 )
		break;
	case VrtSet_qVAxYR:
		SprMixSetQ( MSpr.qVAxYR( w0qv, pos1,  f1_diaHf, f2_Rot,  uniV.x, uniV.y) );
		 //qVAxYR( w0qv, vec3 cP, float diaHf, int mainRotUg, int ot0Ug=45, int ot180Ug=45 )
		break;

	case VrtSet_qVRay: //qVRay( w0qv, vec3 cP, flo, flo LenHafW, int, int modeW=0, float modeW2=2.f)
		SprMixSetQ( MSpr.qVRay( w0qv, pos1, LenMain, f1_diaHf, f2_Rot, RayMode, uniV.x) );

		break;
	case VrtSet_qVRay2: //qVRay2( w0qv, vec3 cP, vec3 cP2, float LenHafW, int mode=0)
		SprMixSetQ( MSpr.qVRay2( w0qv, pos1, uniV, f1_diaHf, RayMode) );
		break;
	default: break;
	}

}














	int Quads1_rec::SetRStates( int in2D)
	{
		//SetShader( tcase);

			if(in2D) glVertexPointer( 2, GL_FLOAT, 0, MSpr.Vert2D );
			else glVertexPointer( 3, GL_FLOAT, 0, MSpr.Vert );

		glColorPointer( 4, GL_FLOAT, 0, MSpr.fRGBA ); //   

		glEnableClientState( GL_VERTEX_ARRAY );
		glEnableClientState( GL_COLOR_ARRAY );


			// ---
		if( tex1 < 1) {pix1.off();}
		else { pix1.use( tex1); OGL::TexClamp(); }
		//TexUnitSet( 0,  tex1, 0);	OGL::TexClamp(); // mod
		//TexUnitSet( 1,  tex2, 1);	OGL::TexClamp(); // decal // alfa

		OGL::KlientTexC_OFF(0);
		//OGL::KlientTexC_OFF(1);

		if(tex1 > 0) OGL::KlientTexCoord(0, MSpr.UV1);
		//if(tex1 > 0 || tex2 > 0)
		//{
		//	if(tex1 > 0) OGL::KlientTexCoord(0, MSpr.UV1);
		//	if(tex2 > 0) OGL::KlientTexCoord(1, MSpr.UV2);
		//}
		return 1;
	}


















// --- public tz_Quad..




	int tz_Quad::Add( int decalGate, Fgr* pFgr,
			int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{
		if( ! DrawActive) return 0;
		if(m1Now >= tz_Quad_m1Last) return 0;

		int i = rism.Kam_DecalMode();
		if( i )
		{ //   - //  decalGate   DecalMode,    
			if(i != decalGate) return 0;
		}
		else // .
		{ //   " " ,     .
			if(decalGate) return 0;
		}

		int staZ = staVersGet();
		//if( staZ < 0) return 0;


		m1Now += 1;

		pRecAddNow = &( m1[ m1Now] ); //    AddPr & AddFree

		pRecAddNow->texDifr = difTex;
		pRecAddNow->tcase = tCase;
		pRecAddNow->tex1 = Tex1;
		pRecAddNow->tex2 = Tex2;
		pRecAddNow->pF   = pFgr;
		pRecAddNow->inFgr = NomZkzInFgr;



		if( staZ)
		{

			for(  i = staZ; i <= tz_Quad_m2Last; i++) //   
			{	if( m2[ i] != 0) //  
				{
					if( Same1( m2[ i],  tCase, Tex1, Tex2, difTex) )
						{ Adv( i, m1Now);  return 1; }
				}
			}
			for( i = staZ; i <= tz_Quad_m2Last; i++)
			{	if( m2[ i] == 0)
				{
					klvVersAdv(); //    
					Adv( i, m1Now);  return 1;
				}
			}
		}
		else //   Add    
		{
			for( i = 1; i <= tz_Quad_m2Last; i++) //  
			{	if( m2[ i] == 0) //  
				{
					staVersSet(i);//       Add
					klvVersAdv(); // = 0 + 1;
					Adv( i, m1Now);  return 1;
				}
			}
		}

	return 0;
	}




		// -    -        .
	int tz_Quad::AddFree( int decalGate, t_SpriteAnk* pAnketa,
			int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{
		if( ! pAnketa) return 0;
		if( ! Add( decalGate,  NULL, NomZkzInFgr, tCase, Tex1, Tex2, difTex) ) return 0;

		if( pRecAddNow) {pRecAddNow->pAnk = pAnketa;  pRecAddNow = 0;}
		return 1;
	}


		//   void setSprite(int nom);      setSprite
	int tz_Quad::AddPr( int decalGate,  void (*pProcSetQuad)(int),
			int NomZkzInFgr, int tCase, int Tex1, int Tex2, int difTex)
	{
		if( ! pProcSetQuad) return 0;
		if( ! Add( decalGate,  NULL, NomZkzInFgr, tCase, Tex1, Tex2, difTex) ) return 0;

		if( pRecAddNow) {pRecAddNow->pProcSetQ = pProcSetQuad;  pRecAddNow = 0;}
		return 1;
	}








	void tz_Quad::Run( int staZ, int klvZ, int in2D)
	{
		if(staZ < 1) return;
		if(klvZ < 1) return;
		klvZ = staZ + klvZ; // klvZ   

		Quads1_rec* r1 = NULL;

		for( int i = staZ; i < klvZ; i++) //   
		{
			if( i > tz_Quad_m2Last) break;
			if( ! m2[ i] ) break;
			r1 = m2[ i];

			MSpr.Tek2D = in2D;

			MSpr.TekV = 0; //   //   ()

				//  -   .
			while( r1 ) //  -
			{
				if( ! r1->pF)
				{
					if( ! MSpr.NextQuad_Non() )
					{
						if( r1->pProcSetQ) r1->pProcSetQ( r1->inFgr );
						else if(r1->pAnk) r1->pAnk->TrySetQ();
					}
				}
				else //   "- "
				{
					r1->pF->OnR_inFgr = r1->inFgr;
					r1->pF->TryOnRender();
				}

				r1 = r1->next;
			}




			if(MSpr.TekV < 4) continue; //    -


			//  -  -  
			// r1 now is NULL
			m2[i]->SetRStates( in2D); // <<<<<------   -

			if(m2[i]->tex1 < 0)
				{glPolygonMode(GL_FRONT, GL_LINE);glPolygonMode(GL_BACK, GL_LINE);}


			glDrawArrays(GL_QUADS, 0, MSpr.TekV );


			if(m2[i]->tex1 < 0)
				{glPolygonMode(GL_FRONT, GL_FILL);glPolygonMode(GL_BACK, GL_FILL);}

		}//for i

		OGL::KlientVertexOFF();
		OGL::KlientColorOFF();
		OGL::KlientTexC_OFF(0);
		//OGL::KlientTexC_OFF(1);

	}
























// ----------
//void an_kamOnStartRoot( kam* k)
//{
//	//     " ".
//	if(pSunFlr2) //     - //-  -
//	{
//		if( ! o2::TopView)
//		{  //      .
//			pSunFlr2->bs.Pos( k->pos() + GlobVector_ViewToSunDst );
//		}
//		else pSunFlr2->SkipDraw();
//	}
//
//	// ...
//}

void glavEkranCopy( kam* pFrom)
{
	if( ! pFrom) return;
	//       (  -  )
	//        glavEkranKam
	//   (     )
	//         OnStartLap
	//     " " - -    " ".
	// -      ,    .
	// ,      ,      
	//      - -       ...
	// ---
	//  glavEkranKam        
	//  "  ".      
	//      -     
	//    " ,    " ...

	glavEkranKam.VPx = pFrom->VPx;
	glavEkranKam.VPy = pFrom->VPy;
	glavEkranKam.VPw = pFrom->VPw;
	glavEkranKam.VPh = pFrom->VPh;

	glavEkranKam.Flat = pFrom->Flat;

	glavEkranKam.Flat__KamScW = pFrom->Flat__KamScW;
	glavEkranKam.Flat__KamScH = pFrom->Flat__KamScH;

	glavEkranKam.px = pFrom->px;
	glavEkranKam.py = pFrom->py;
	glavEkranKam.pz = pFrom->pz;
	glavEkranKam.tx = pFrom->tx;
	glavEkranKam.ty = pFrom->ty;
	glavEkranKam.tz = pFrom->tz;

	glavEkranKam.Proj__ObzorY = pFrom->Proj__ObzorY;
	glavEkranKam.Proj__Aspect = pFrom->Proj__Aspect;
	glavEkranKam.ZNear =      pFrom->ZNear;
	glavEkranKam.ZFar =     pFrom->ZFar;

	glavEkranKam.pFgr = pFrom->pFgr;

	memcpy( &glavEkranKam.KameraBaseModelMatrix[0],
				&pFrom->KameraBaseModelMatrix[0], sizeof(double) * 16);

	memcpy( &glavEkranKam.KameraProjMatrix[0],
				&pFrom->KameraProjMatrix[0], sizeof(double) * 16);

}











	void kam::OnStaSelfRun()
	{
//		if(toTex)
//		{ // 
//PixBuf512_1.Activate();
//		}

		if( DecalMode == 0)
		{
			//,  -     
			//            .
			//    ,       
			//          ( ).

			set1_VPort(1);
			set2_Proj();
			set3_Look();

			if(glavEkran) glavEkranCopy( this);

			//if( any_Quad_Use ) //      tz_Quad
				rose.UpdMatrix();

			//an_kamOnStartRoot( this);
		}

		if(DecalMode)
		{	glPolygonOffset( -1.f, -1.f ); //( 1.f, 2.f );
			glEnable( GL_POLYGON_OFFSET_FILL );
		}
		else glDisable( GL_POLYGON_OFFSET_FILL );

	}


	void kam::OnFinSelfRun()
	{

		//if(toTex)
		//{ // 
		//	pix1.use(toTex);  glEnable( GL_TEXTURE_2D );
		//	glCopyTexSubImage2D( GL_TEXTURE_2D, 0,    0, 0,   0, 0, VPw, VPh);
//PixBuf512_1.Deactivate();
		//}

		glDisable( GL_POLYGON_OFFSET_FILL ); //   

	}










// ----------------- public t_kams ..


//    -     .
//    -,    " "   , 
//    -      .
//      - ""  .


	void t_kams::add( Fgr* p, int prior)
	{
		if(!p) return;
		if(prior < 1) return;
		if( mkNowEmpty >= kams_speKlv) return;


		kam* n = &mk[mkNowEmpty];  mkNowEmpty += 1;

			n->status = p->kmra_statusMode; //1;
			n->prior = prior;
			n->pFgr = p;

		n->glavEkran = p->kmra_glavEkran;
		n->toTex =   p->kmra_toTex;
		n->DecalMode = p->kmra_DecalMode;
		n->VPx =  p->kmra_VPx;
		n->VPy =  p->kmra_VPy;
		n->VPw =  p->kmra_VPw;
		n->VPh =  p->kmra_VPh;
		n->ScisX = p->kmra_ScisX;
		n->ScisY = p->kmra_ScisY;
		n->ScisW = p->kmra_ScisW;
		n->ScisH = p->kmra_ScisH;

	n->Flat = p->kmra_Flat;
	n->Flat__KamScW = p->kmra_Flat__KamScW;
	n->Flat__KamScH = p->kmra_Flat__KamScH;
	n->px = p->ox;
	n->py = p->oy;
	n->pz = p->oz;
	n->tx = p->laserX;
	n->ty = p->laserY;
	n->tz = p->laserZ;
	n->Proj__ObzorY = p->kmra_Proj__ObzorY;
	n->Proj__Aspect = p->kmra_Proj__Aspect;
	n->ZNear = p->kmra_ZNear;
	n->ZFar = p->kmra_ZFar;



		if(mkNowEmpty < 2)
		{
			pFirst = n;
			return; // 
		}

		kam* k = pFirst;

		if(mkNowEmpty == 2) //   .
		{
				if( n->prior < k->prior) //,  .
					{	pFirst = n;  n->pTail = k;  k->pPrev = n;}
				else{	pFirst = k;  k->pTail = n;  n->pPrev = k;}

			return;
		}


		while( k)
		{
			if( n->prior < k->prior)
			{
				kam* k2 = k->pPrev;
				if(k2){ k2->pTail = n;  n->pPrev = k2; }
				n->pTail = k;  k->pPrev = n;

				return;
			}
			if( ! k->pTail)
			{
				k->pTail = n;  n->pPrev = k;

				return;
			}
			k = k->pTail;
		}

	}





	kam* t_kams::NextForDraw( kam* pKamNow)
	{
		kam* k;
		if( ! pKamNow) k = pFirst; else k = pKamNow->pTail;
		if( ! k) return 0;

		//  "  ".
		// ,  - ,       .

		if( k->DecalMode == 0)
		{
			k->set1_VPort();
			k->set2_Proj();
			k->set3_Look(1);

			Fru1.Update(); //    set1 set2 set3

			//      //rose.UpdMatrix();
		}

	//   -   .
	//   ,  "-" (   ).
	// ,      .

		return k;
	}



	kam* t_kams::NextForRun( kam* pKamNow)
	{
		kam* k;
		if( ! pKamNow) k = pFirst; else k = pKamNow->pTail;
		if( ! k) return 0;

		// ---    
		// , -, , ,  
		k->OnStaSelfRun();

			// ---

		OGL::KlientVertexOFF();
		OGL::KlientNrmOFF();
		OGL::KlientColorOFF();
		OGL::KlientTexC_OFF(0);

		glDepthFunc(GL_LEQUAL); // - = ,   .
		glDepthMask( GL_TRUE );
		glEnable( GL_DEPTH_TEST );

		glDisable(GL_FOG);   //  .
		glDisable(GL_LIGHTING); //  .
		glDisable(GL_BLEND); //  .

		glDisable(GL_ALPHA_TEST); //   - .
		//glEnable(GL_ALPHA_TEST);
		//glAlphaFunc(GL_GREATER, 0.1f); //- 0.1   =  .

		glEnable(GL_CULL_FACE); // " "  .
		glFrontFace(GL_CCW); //""    " ".
		glCullFace(GL_BACK); // ""  .

		return k;
	}















// -------------------

kam* pRM_KamNow = 0;
	//        .





void tz_Mesh::staVersSet(int nom)
{
	if( ! pRM_KamNow) return;
	switch(vers)
	{
	case tzv_Mesh:   pRM_KamNow->Sta_Mesh  = nom; break;
	case tzv_MeshM:  pRM_KamNow->Sta_MeshM  = nom; break;
	case tzv_MeshA:  pRM_KamNow->Sta_MeshA   = nom; break;
	case tzv_MeshA2s:pRM_KamNow->Sta_MeshA2s = nom; break;
	default: break;
	}
}

int tz_Mesh::staVersGet()
{
	if( ! pRM_KamNow) return 0;
	switch(vers)
	{
	case tzv_Mesh: return    pRM_KamNow->Sta_Mesh;
	case tzv_MeshM: return   pRM_KamNow->Sta_MeshM;
	case tzv_MeshA: return   pRM_KamNow->Sta_MeshA;
	case tzv_MeshA2s: return pRM_KamNow->Sta_MeshA2s;
	default: break;
	}
	return 0;
}

void tz_Mesh::klvVersAdv()
{
	if( ! pRM_KamNow) return;
	switch(vers)
	{
	case tzv_Mesh:    pRM_KamNow->Klv_Mesh  += 1; break;
	case tzv_MeshM:   pRM_KamNow->Klv_MeshM  += 1; break;
	case tzv_MeshA:   pRM_KamNow->Klv_MeshA   += 1; break;
	case tzv_MeshA2s: pRM_KamNow->Klv_MeshA2s += 1; break;
	default: break;
	}
}










// --------------------



void tz_Quad::staVersSet(int nom)
{
	if( ! pRM_KamNow) return;
	switch(vers)
	{
	case tzv_Quad:   pRM_KamNow->Sta_Quad  = nom; break;
	case tzv_QuadM:  pRM_KamNow->Sta_QuadM  = nom; break;
	case tzv_QuadA2d:pRM_KamNow->Sta_QuadA2d = nom; break;
	case tzv_QuadA:  pRM_KamNow->Sta_QuadA   = nom; break;
	case tzv_QuadA2s:pRM_KamNow->Sta_QuadA2s = nom; break;
	case tzv_Quad2d: pRM_KamNow->Sta_Quad2d = nom; break;

	default: break;
	}
}

int tz_Quad::staVersGet()
{
	if( ! pRM_KamNow) return 0;
	switch(vers)
	{
	case tzv_Quad: return    pRM_KamNow->Sta_Quad;
	case tzv_QuadM: return   pRM_KamNow->Sta_QuadM;
	case tzv_QuadA2d: return pRM_KamNow->Sta_QuadA2d;
	case tzv_QuadA: return   pRM_KamNow->Sta_QuadA;
	case tzv_QuadA2s: return pRM_KamNow->Sta_QuadA2s;
	case tzv_Quad2d: return  pRM_KamNow->Sta_Quad2d;

	default: break;
	}
	return 0;
}

void tz_Quad::klvVersAdv()
{
	if( ! pRM_KamNow) return;
	switch(vers)
	{
	case tzv_Quad:    pRM_KamNow->Klv_Quad  += 1; break;
	case tzv_QuadM:   pRM_KamNow->Klv_QuadM  += 1; break;
	case tzv_QuadA2d: pRM_KamNow->Klv_QuadA2d += 1; break;
	case tzv_QuadA:   pRM_KamNow->Klv_QuadA   += 1; break;
	case tzv_QuadA2s: pRM_KamNow->Klv_QuadA2s += 1; break;
	case tzv_Quad2d:  pRM_KamNow->Klv_Quad2d += 1; break;

	default: break;
	}
}























// ----------------------- meh_RenderMash ..


/*
int KVertex( GLuint Buf, int forceUse = 0 )
{
	if( ! Buf ) {KVertexOFF(); return 0;}
	if(forceUse == 0 && KVertex_ID == Buf)
		{glEnableClientState( GL_VERTEX_ARRAY ); return 1;}
	KVertex_ID = Buf;

	glBindBufferARB( GL_ARRAY_BUFFER_ARB, Buf );
		glVertexPointer( 3, GL_FLOAT, 0, NULL );
		glEnableClientState( GL_VERTEX_ARRAY );
	return 1;
}

int KNormal( GLuint Buf, int forceUse = 0 )
{
	if( ! Buf ) {KNormalOFF(); return 0;}
	if(forceUse == 0 && KNormal_ID == Buf)
		{glEnableClientState( GL_NORMAL_ARRAY ); return 1;}
	KNormal_ID = Buf;

	glBindBufferARB( GL_ARRAY_BUFFER_ARB, Buf );
		glNormalPointer( GL_FLOAT, 0, NULL );
		glEnableClientState( GL_NORMAL_ARRAY );
	return 1;
}

int KColor4b( GLuint Buf, int forceUse = 0 )
{
	if( ! Buf ) {KColorOFF(); return 0;}
	if(forceUse == 0 && KColor_ID == Buf)
		{glEnableClientState( GL_COLOR_ARRAY ); return 1;}
	KColor_ID = Buf;

	glBindBufferARB( GL_ARRAY_BUFFER_ARB, Buf );
		glColorPointer( 4, GL_UNSIGNED_BYTE, 0, NULL );
		glEnableClientState( GL_COLOR_ARRAY );
	return 1;
}

int KTexCoord(int LayFr0, GLuint Buf, int texC_ON = 1)
{ warning
	KTexLay( LayFr0);
	if( ! Buf ) {KTexCoordOFF(); return 0;}

		glBindBufferARB( GL_ARRAY_BUFFER_ARB, Buf );
		glTexCoordPointer( 2, GL_FLOAT, 0, NULL);

	if(texC_ON) glEnableClientState( GL_TEXTURE_COORD_ARRAY );
	return 1;
}
*/









// ------ private meh_RenderMash ..



void meh_RenderMash::KVertex( vec3* mas, int forceUse)
{
	if( ! mas ) {KVertexOFF(); return;}
	if(forceUse == 0 && KVertex_p == mas)
		{glEnableClientState( GL_VERTEX_ARRAY ); return;}
	KVertex_p = mas;

	glVertexPointer( 3, GL_FLOAT, 0, &mas[0].x );
		glEnableClientState( GL_VERTEX_ARRAY );
}
void meh_RenderMash::KVertexOFF() {glDisableClientState( GL_VERTEX_ARRAY );}


void meh_RenderMash::KNormal( vec3* mas, int forceUse)
{
	if( ! mas ) {KNormalOFF(); return;}
	if( forceUse == 0 && KNormal_p == mas)
		{ glEnableClientState( GL_NORMAL_ARRAY ); return;}
	KNormal_p = mas;

	glNormalPointer( GL_FLOAT, 0, &mas[0].x );
		glEnableClientState( GL_NORMAL_ARRAY );
}
void meh_RenderMash::KNormalOFF() {glDisableClientState( GL_NORMAL_ARRAY );}


void meh_RenderMash::KColor4b( BYTE* mas, int forceUse)
{
	if( ! mas ) {KColorOFF(); return;}
	if( forceUse == 0 && KColor_p == mas)
		{glEnableClientState( GL_COLOR_ARRAY ); return;}
	KColor_p = mas;

	glColorPointer( 4, GL_UNSIGNED_BYTE, 0, mas );
		glEnableClientState( GL_COLOR_ARRAY );
}
void meh_RenderMash::KColorOFF()
{
	glDisableClientState( GL_COLOR_ARRAY );
	glEnable( GL_COLOR_MATERIAL);
}


void meh_RenderMash::KTexCoord( vec2* mas, int forceUse)
{
	//	KlientTexSlo( nomFr0);
	if( ! mas ) {KTexCoordOFF(); return;}
	if( forceUse == 0 && KTexC1_p == mas)
		{glEnableClientState( GL_TEXTURE_COORD_ARRAY ); return;}
	KTexC1_p = mas;

	glTexCoordPointer( 2, GL_FLOAT, 0, mas);
		glEnableClientState( GL_TEXTURE_COORD_ARRAY );
}
void meh_RenderMash::KTexCoordOFF() {glDisableClientState( GL_TEXTURE_COORD_ARRAY );}









void meh_RenderMash::GeneralTiugVrtSet(int useColorMat)
{
	//genM.klvNow
	KVertex( genM.vrt);
	KNormal( genM.nrm);
	if(useColorMat) KColor4b( NULL);
	else KColor4b( &genM.clr[0][0]);
	KTexCoord(genM.uv1);
}

void meh_RenderMash::LocalTiugVrtSet(
 vec3* pV, vec3* pN, BYTE* pRGBA, vec2* pUV, vec2* pUV2)
{
	KVertex( pV);
	KNormal( pN);
	KColor4b( pRGBA);
	KTexCoord(pUV);
	//KTexCoord(pUV2);
}




// --------- public meh_RenderMash ..


meh_RenderMash::meh_RenderMash()
{

	Mesh.setVers(    tzv_Mesh);
	Quad.setVers(    tzv_Quad);

	MeshM.setVers(   tzv_MeshM);
	QuadM.setVers(   tzv_QuadM);

	QuadA2d.setVers( tzv_QuadA2d);

	MeshA.setVers(   tzv_MeshA);
	MeshA2s.setVers( tzv_MeshA2s);

	QuadA.setVers(   tzv_QuadA);
	QuadA2s.setVers( tzv_QuadA2s);

	Quad2d.setVers(  tzv_Quad2d);

}





	void meh_RenderMash::OnNewLap()
	{
		pRM_KamNow = 0;

		kams.reset();
			//        Sta_ Klv_

		Mesh.Reset();
		Quad.Reset();

		MeshM.Reset();
		QuadM.Reset();

		QuadA2d.Reset();

		MeshA.Reset();
		MeshA2s.Reset();

		QuadA.Reset();
		QuadA2s.Reset();

		Quad2d.Reset();


		KVertex_p = 0; // --
		KNormal_p = 0;
		KColor_p = 0;
		KTexC1_p = 0;

		// KVertex_ID = 0;
		// KNormal_ID = 0;
		// KColor_ID = 0;
		// KTexC1_ID = 0;

	}





	void meh_RenderMash::FotoKamParad( Fgr* pMF)
	{
		if( ! pMF) return; //pMF   

		kams.add( pMF, pMF->kmra_prior );
			//      pMF
	}







	int meh_RenderMash::kams_NextForDraw()
	{
		pRM_KamNow = kams.NextForDraw( pRM_KamNow);
		if( pRM_KamNow) return 1;
		return 0;
	}



	int meh_RenderMash::Kam_SameStudio()
	{//        
		if( ! pRM_KamNow) return 0;
		//if( pRM_KamNow->studio != anStudio) return 0;
		return 1;
	}


	int meh_RenderMash::Kam_Fru()
	{//        
		if( ! pRM_KamNow) return 0;
		//if( ! pRM_KamNow->Fru( gab, spe) ) return 0;
		return 1;
	}

	int meh_RenderMash::Kam_LowLOD()
	{
		if( ! pRM_KamNow) return 0;
		//if( pRM_KamNow->needLowLOD ) return 1;
		return 0;
	}

	int meh_RenderMash::Kam_DecalMode()
	{
		if( ! pRM_KamNow) return 0;
		if( pRM_KamNow->DecalMode ) return 1;
		return 0;
	}

	int meh_RenderMash::Kam_glavEkran()
	{
		if( ! pRM_KamNow) return 0;
		if( pRM_KamNow->glavEkran ) return 1;
		return 0;
	}







void RM_AlfMask_Begin( float LowA = 0.1f, int cullFaceOff=1)
{
	//  -     
	//    " -" (0.f  1.f)
	NomBlend(38); // glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, LowA); //   -   -
	if(cullFaceOff) glDisable(GL_CULL_FACE);
}

void RM_AlfMask_End()
{
	glEnable(GL_CULL_FACE);
	glDisable(GL_ALPHA_TEST);
}


void RM_Ghost_Begin(int cullFaceOff=1)
{ //       - 
	NomBlend(34); // glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glDepthMask( GL_FALSE ); //    .
	glEnable(GL_DEPTH_TEST); //    "-  ".
	if(cullFaceOff) glDisable(GL_CULL_FACE);
}

void RM_Ghost_End()
{
	glEnable(GL_CULL_FACE);
	glDepthMask( GL_TRUE );
	glEnable(GL_DEPTH_TEST);

}







	void meh_RenderMash::Run()
	{
		//     ..

		kam* p  = 0;
		kam* pGK = 0;

		while( p = kams.NextForRun( p) )
		{
			pRM_KamNow = p; //  .     ...


			//     DecalMode,     
			if(p->glavEkran && p->DecalMode == 0)
				pGK = p; //,      .



			//p->SetRunSession(); //, -, , ,  
			//       NextForRun()

			// ---
			//          .


			// ---   -    .
		//	if( p->Klv_Quad2d && Quad2d.gNow() )
		//	{
		//		//    -   0.99,   
		//		//       ,    "".
		//
		//		Quad2d.Run( p->Sta_Quad2d, p->Klv_Quad2d );
		//	}



			// ---  - ( -)

			if( p->Klv_Mesh && Mesh.gNow() ) //      .
			{
				Mesh.Run( p->Sta_Mesh, p->Klv_Mesh );
			}
			//Mesh.DrawActive = o2::TestFgrDrawMesh;

			if( p->Klv_Quad && Quad.gNow() )
			{
				Quad.Run( p->Sta_Quad, p->Klv_Quad );
			}
			//Quad.DrawActive = o2::TestFgrDrawQuad;



			// ---  - (-)

			if( p->Klv_MeshM && MeshM.gNow() )
			{
				RM_AlfMask_Begin(); // 0.2f, 0);
					MeshM.Run( p->Sta_MeshM, p->Klv_MeshM );

				RM_AlfMask_End();
			}
			//MeshM.DrawActive = o2::TestFgrDrawMeshM;

			if( p->Klv_QuadM && QuadM.gNow() )
			{
				RM_AlfMask_Begin();
					QuadM.Run( p->Sta_QuadM, p->Klv_QuadM );

				RM_AlfMask_End();
			}
			//QuadM.DrawActive = o2::TestFgrDrawQuadM;
			//      ,     .



			// ---    -      - 
			//     .






			// ---    ()

			if( p->Klv_MeshA && MeshA.gNow() )
			{
				RM_Ghost_Begin(0);
					MeshA.Run( p->Sta_MeshA, p->Klv_MeshA );

				RM_Ghost_End();
			}
			if( p->Klv_MeshA2s && MeshA2s.gNow() )
			{
				RM_Ghost_Begin(1);
					MeshA2s.Run( p->Sta_MeshA2s, p->Klv_MeshA2s );

				RM_Ghost_End();
			}




			if( p->Klv_QuadA && QuadA.gNow() )
			{
				RM_Ghost_Begin(0);
					QuadA.Run( p->Sta_QuadA, p->Klv_QuadA );

				RM_Ghost_End();
			}
			if( p->Klv_QuadA2s && QuadA2s.gNow() )
			{
				RM_Ghost_Begin(1);
					QuadA2s.Run( p->Sta_QuadA2s, p->Klv_QuadA2s );

				RM_Ghost_End();
			}







			//         .
			//     -   -.

			p->OnFinSelfRun(); // -   "  "
		}
		//while





		if(pGK) //  .
		{
			//  pGK       -.
			//    "   ".
			//   -    ,   
			//       ...

			// ---
			//pGK->OnStaSelfRun();    .

			glViewport( pGK->VPx, pGK->VPy,  pGK->VPw, pGK->VPh ); //pGK->set1_VPort(0);
			pGK->set2_Proj();
			pGK->set3_Look(); // glProject  

			//if( pGK->Klv_QuadA2d || pGK->Klv_Quad2d)
				rose.UpdMatrix();


			// ---
			OGL::KlientVertexOFF();
			OGL::KlientNrmOFF();
			OGL::KlientColorOFF();
			OGL::KlientTexC_OFF(0);

			glDisable(GL_FOG);
			glDisable(GL_LIGHTING);

			glEnable(GL_CULL_FACE);


			Begin2D( pGK->VPx, pGK->VPw, pGK->VPy, pGK->VPh);

			// --- -  ..
			if( (! pGK->toTex) && pGK->Klv_QuadA2d && QuadA2d.gNow() )
			{
				NomBlend(34);
					QuadA2d.Run( pGK->Sta_QuadA2d, pGK->Klv_QuadA2d, 1 );
			}


			// --- -     .
			// RTabGen_UpdDraw    "- Quad2d".
			if( pGK->Klv_Quad2d && Quad2d.gNow() )
			{
				NomBlend(38);
					Quad2d.Run( pGK->Sta_Quad2d, pGK->Klv_Quad2d, 1 );
			}

			End2D();
		}


		//NomBlend(0); // TEST
		//DrawRoseR360();

	}
	// Run












	void meh_RenderMash::dip1( int meshNom)
	{
		//  -     

	//	meshTiug* pM = meshBook.get_( meshNom);  if(!pM) return;
	//	if( ! pM->OK() ) return;

		//   -  "dip"
		//dip( pM->indKlv, pM->pInd(), pM->pVrt(),
		//		pM->pNrm(), pM->pClrB4(), pM->pUV1() );

		// UINT* meshTiug::pInd()
		// {return &(Faces[0][0]);// Faces[_][0 1 2]
		// }
		return;
	}


	void meh_RenderMash::dip( int iKlv, UINT* pInd, vec3* pV,
		vec3* pN, BYTE* pRGBA, vec2* pUV, vec2* pUV2 )
	{
		// "  ",   "  VBO"
		if( iKlv < 3) return; //   .
		if( ! pInd) return; //   .

		// ---
		//   -  ,   
		//  .      .
		if(! pV)  GeneralTiugVrtSet(); // GeneralTiugVrtSet( UseColorMat );
		else LocalTiugVrtSet( pV, pN, pRGBA, pUV, pUV2);

		glDrawElements( GL_TRIANGLES, iKlv, GL_UNSIGNED_INT, pInd );
	}



	//void meh_RenderMash::dipg( int iKlv, UINT* pInd, int CaseColorMat = 1)
	//{
	//	if( iKlv < 3) return;
	//	if( ! pInd) return;
	//	// OGL_SetColorMat( CaseColorMat); // 
	//	GeneralTiugVrtSet( CaseColorMat);
	//	glDrawElements( GL_TRIANGLES, iKlv, GL_UNSIGNED_INT, pInd );
	//}





