//


const WORD ogl_SelBufKlv = 7000;
UINT ogl_SelectBuffer[ogl_SelBufKlv];


 //   Fgrs.renderForSelect();
void FgrsRenderForSelect( int onlyUnits);








const int OGL_SelectMassObj_mLast = 705;
UINT OGL_SelectMassObj_m[ OGL_SelectMassObj_mLast+1];


	//         
int OGL_SelectMassObj( int onlyUnits, int cx, int cy, kam* pK, int xw=3, int yh=3 )
{
	if( ! pK ) return 0;

	if( xw > pK->VPw ) xw = pK->VPw;
	if( yh > pK->VPh ) yh = pK->VPh;
	if( xw < 3 ) xw = 3;
	if( yh < 3 ) yh = 3;

	int objectsFound = 0;

	glSelectBuffer( ogl_SelBufKlv, ogl_SelectBuffer);
	glRenderMode( GL_SELECT );

	glViewport( pK->VPx, pK->VPy,  pK->VPw, pK->VPh ); //  pK->set1_();


	// ---

	glMatrixMode(GL_PROJECTION);
	glPushMatrix(); // GL_PROJECTION {
		glLoadIdentity();

// --------- -    .
// cx, cy  //The center of a picking region in window coordinates.
//width, height
// The width and height, respectively, of the picking region in window coordinates.

		gluPickMatrix( cx, cy,   xw, yh,  &(pK->VPx));

		pK->set2_Proj(0); //      ...

			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
					pK->set3_Look(1);
						FgrsRenderForSelect(onlyUnits); //   .

			glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();	// GL_PROJECTION }
	glMatrixMode(GL_MODELVIEW);		// Go back to our normal model view matrix




	// ---

	objectsFound = glRenderMode(GL_RENDER); //      

	if( objectsFound > 0 )
	{
		if(objectsFound > (OGL_SelectMassObj_mLast+1)) objectsFound = OGL_SelectMassObj_mLast+1;
		OGL_SelectMassObj_m[0] = ogl_SelectBuffer[3];

		for( int i = 1; i < objectsFound; i++) //    //    
		{
			OGL_SelectMassObj_m[i] = ogl_SelectBuffer[(i * 4) + 3];
		}
		return objectsFound;
	}

return 0; //     .
}











	//   UINT    . ( --,  )
UINT OGL_SelectOneObj( int onlyUnits, int cx, int cy, kam* pK, int xw=3, int yh=3 )
{
	if( ! pK ) return 0;

	if( xw > pK->VPw ) xw = pK->VPw;
	if( yh > pK->VPh ) yh = pK->VPh;
	if( xw < 3 ) xw = 3;
	if( yh < 3 ) yh = 3; //  - ,     


	int objectsFound = 0;

	glSelectBuffer( ogl_SelBufKlv, ogl_SelectBuffer);
	glRenderMode( GL_SELECT );

	glViewport( pK->VPx, pK->VPy,  pK->VPw, pK->VPh );


	// ---

	glMatrixMode(GL_PROJECTION);
	glPushMatrix(); // GL_PROJECTION {
		glLoadIdentity();

		gluPickMatrix( cx, cy,   xw, yh,  &(pK->VPx));

		pK->set2_Proj(0); //      ...

			glMatrixMode(GL_MODELVIEW);
			glPushMatrix();
					pK->set3_Look(1);
						FgrsRenderForSelect(onlyUnits); //   .

			glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();	// GL_PROJECTION }
	glMatrixMode(GL_MODELVIEW);		// Go back to our normal model view matrix




	// ---

	objectsFound = glRenderMode(GL_RENDER); //      

	if( objectsFound > 0 )
	{
		UINT lowestDepth = ogl_SelectBuffer[1];
		UINT selectedObject = ogl_SelectBuffer[3];

		for( int i = 1; i < objectsFound; i++)
		{
			if( ogl_SelectBuffer[(i * 4) + 1] < lowestDepth )
			{
				lowestDepth = ogl_SelectBuffer[(i * 4) + 1];
				selectedObject = ogl_SelectBuffer[(i * 4) + 3];
			}
		}
		return selectedObject;
	}

return 0; //    .
}













float GetPointUnderKurs_testWnZ;

int GetPointUnderKurs( vec3& anPnt, int KlikX, int KlikY, kam* pK)
{
	if( ! pK ) return 0;

	double wnx=KlikX, wny=KlikY, wnz=0;
	float fd;
	double objx, objy, objz;



// --- glReadPixels
// PixelFormat:
//GL_COLOR_INDEX, GL_STENCIL_INDEX, GL_DEPTH_COMPONENT,
//GL_RED, GL_GREEN, GL_BLUE, GL_ALPHA,
//GL_RGB, GL_RGBA, GL_LUMINANCE, GL_LUMINANCE_ALPHA
//----------------



//	if( Ekran.DepthBits == 24 ) // COMPONENT24_ARB -  //     ...
//		glReadPixels( int(wnx), int(wny), 1, 1, GL_DEPTH_COMPONENT24_ARB, GL_FLOAT, &fd );
//	else
		glReadPixels( int(wnx), int(wny), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &fd );
	wnz = fd; // -       0..1
	GetPointUnderKurs_testWnZ = fd;


	if( gluUnProject( wnx, wny, wnz,  pK->KameraBaseModelMatrix,
			pK->KameraProjMatrix,   &(pK->VPx), &objx, &objy, &objz) == GL_TRUE )
	{
		anPnt.x = objx;		anPnt.y = objy;		anPnt.z = objz;
		return 1;
	}
//gluUnProject(x, y,   ,  ,  ,  ,
//	 ,  Y,  Z).

	return 0;
}









int GetPointToEkran( vec3 anPnt, int& ekX, int& ekY, kam* pK)
{
	if( ! pK ) return 0;
	double objx = anPnt.x;
	double objy = anPnt.y;
	double objz = anPnt.z;
	double winx, winy, winz;

	ekX = ekY = -1; // 9990

	if( gluProject( objx, objy, objz,  pK->KameraBaseModelMatrix,
			pK->KameraProjMatrix,  &(pK->VPx),  &winx, &winy, &winz) == GL_TRUE )
	{
		ekX = (int)winx;  ekY = (int)winy;  return 1;
	}
return 0;
}





