//   a_mem.h

// a15_files_a.h


//extern packfile_t* gPakFile; // .
//#define INC_PACKFILE1



class t_Char128
{ public:
	char Buf[128];
	void Clear() { for (int t=0; t < 128; t++) Buf[t] = '\0'; };
};

class t_Char256
{ public:
	char Buf[256];
	void Clear() { for (int t=0; t < 256; t++) Buf[t] = '\0'; };
};


// convStr05_a.h


BYTE SToByte(const sStr& s);
short SToShort(const sStr& s);
WORD SToUShort(const sStr& s);
int SToInt(const sStr& s);
UINT SToUInt(const sStr& s);
float SToFlo(const sStr& s);
double SToDbl(const sStr& s);

	// minimChars as 7 is max
std::string IntToS(int i, int minimChars);

std::string IntToS(int i);

sStr ByteToS(BYTE i);

sStr TextUpperS( sStr& s); // Make an uppercase copy of s

sStr TextLowerS( sStr& s); // Make a lowercase copy of s

sStr TextTrimS(const sStr& s);

//   .,  .,   
sStr  TextReplaceS( sStr s, sStr f, sStr new_part);

	// -1=   ., 0   =      
int TextPos(const char* main, sStr f, int from=0);


//   -,    klv      -  
int TextPartSame( sStr& s1, int s1beg,  sStr& s2, int s2beg,  int klv=0);

int RemoveBloksFromString( sStr& s1, sStr beginBlok, sStr endBlok);

int RemoveBloksFrLineWfStrings( sStr& s1, sStr beginBlok, sStr endBlok);

int FindInLineIgnorStrings( sStr& s1, sStr findSt, int from, int nom=1);

void StringLinkLinesRead( sStr& s1, std::ifstream& frs);

int BigKomentSkipRead( sStr& s1, std::ifstream& frs);










int findInStrEND(std::string& s1);

int findInStrBEGIN(std::string& s1, std::ifstream& frs);

int findNonEmptyStr(std::string& s1, std::ifstream& frs);

//   fromPos      -1
std::string NextStringBefComa( std::string& s1, int& fromPos);








sStr MixForString64( const char* fmt, ... );
sStr MixForString300( const char* fmt, ... );

// mode +1000  LocalTime
sStr SysDateString(short mode=0 , short ForceEng=1);

// mode +1000  LocalTime
sStr SysTimeString(short mode=0);

char* MixDateCh(short dateMode=0, short timeMode=0, short forceEng=1);

char* MixDateChLoc(short forceEng=1);











	//             1310
	//     - "- -  1310  -"
	// frs.eatwhite();       
int streamGetToZ1310( std::ifstream& frs );



void ByteRead(BYTE& bb, FILE* ff); //bool   
void ShortRead(short& sh, FILE* ff);
void UShortRead(WORD& sh, FILE* ff);
void IntRead(int& ii, FILE* ff);
void UIntRead(UINT& ii, FILE* ff);
void FloRead(float& fi, FILE* ff);
void DblRead(double& di, FILE* ff);

//----------------------------------------

int ByteWrite(BYTE bb, FILE* ff);
int ShortWrite(short sh, FILE* ff);
int UShortWrite(WORD sh, FILE* ff);
int IntWrite(int ii, FILE* ff);
int UIntWrite(UINT ii, FILE* ff);
int FloWrite(float fi, FILE* ff);
int DblWrite(double di, FILE* ff);




int CharStringWrite( const char* fraza, FILE* ff );


//int CharBlockWrite( const char* fraza, int NWB, FILE* ff )

// NWB: -1=(  )       (  )..
int CharBlockWrite( sStr fraza, int NWB, FILE* ff );



//fread( _, sizeof(_), kolvo, ff);
//fwrite( _, sizeof(_), kolvo, ff);
//..  .,  ,  ., 












//MyFileWrite

// ---------------------
//    ,   - ( win98)
//    .
//   -     .

// re: 0 - (or Add)., 1 ., 2 bak., 3 bak+editOld  (md: 0=wb  1=w+b  2=a+b)
FILE* BinFileWrite( sStr name, sStr ext, short re=0, short md=0);
















// ------------------------------
				//        ByteLenta

//typedef struct
//{	BYTE* Buf;
//	int Pos, Len; // Len = klv .
//		//   -  ( ) 
//		//     " "...
//} ByteLenta;



namespace tByteLenta
{
	const UINT ImgPassp = 456;

	const WORD

	ImgStartPix = 20,
	ImgType_RGB = 1, // rgb bytes
	ImgType_RGBA = 2, // rgba bytes
	ImgType_Alpha = 20, // alpha floats

	ImgHdrYch_Passp = 1,
	ImgHdrYch_Type = 2,
	ImgHdrYch_W = 3,
	ImgHdrYch_H = 4;
};






class ByteLenta
{
public:
	BYTE* Buf;
	int Pos, Len;

	ByteLenta();

	ByteLenta(const ByteLenta& anLenta)	;

	// ourBLenta = anBLenta;
	ByteLenta& operator = (const ByteLenta& RLenta);

	void HoldSqvMix(ByteLenta& LLenta, ByteLenta& RLenta); //   +

		//    ...  memcpy   ,  MovePos=1
	void BlokRead( void* target, int kolvoByte,   int MovePos = 1);

	// ------------------------------

	~ByteLenta();

	void Sbros();
	void MAlloc(UINT NeedBytes=4, short NeedNew=0);

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BYTE ByteRead(short MovePos = 1);
short ShortRead(short MovePos = 1);
WORD UShortRead( short MovePos = 1);
int IntRead( short MovePos = 1);
UINT UIntRead( short MovePos = 1);
float FloRead( short MovePos = 1);
double DblRead( short MovePos = 1);

// ---------

	// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

BYTE AnByteRead(int offset=0);
short AnShortRead(int offset=0);
WORD AnUShortRead(int offset=0);
int AnIntRead(int offset=0);
UINT AnUIntRead(int offset=0);
float AnFloRead(int offset=0);
double AnDblRead(int offset=0);



 //     ., LenCopy=0    ., 1=   
void CopyTo( ByteLenta* bl2,		int LenCopy=0, int SrcFromZero=0);

//------------------------------------

	//   ( )
void AddOtherBL( ByteLenta* anLenta );

void DeleteTailFrom(int FromPos);

	//         . ( 3   2)
int SetLastPos();



int CountEOL(int withNonEndLine=1);

	//     1310  
int SkipToEOL();

	// Tab & Space -   //   48  ...
int SetPosToFirstNormCharInLine( BYTE firstNorm=48 );

void SdvigLenPlus( int ofsSdvig, int klvBytes );

void SdvigLenMinus( int ofsSdvig, int klvBytes );

void CutLenMinus( int ofscut, int klvBytes );




	// Name.,  1  .,  -1  " "., 1 "   ".
int SaveToFile( sStr FileName, int NeedReWrite, int LenCopy, int SrcFromZero);

//------------------------------------

void ByteWrite( BYTE an, short MayAdd=1);
void ShortWrite( short an, short MayAdd=1);
void UShortWrite( WORD an, short MayAdd=1);
void IntWrite( int an, short MayAdd=1);
void UIntWrite( UINT an, short MayAdd=1);
void FloWrite( float an, short MayAdd=1);
void DblWrite( double an, short MayAdd=1);

void FillRand(int caseRND, int beginPos=-1, int LenPart=-1);

	friend ByteLenta operator + (ByteLenta& LLenta, ByteLenta& RLenta);


private:

void Add(int size_an);

							//============
}; //class ByteLenta



	//- -      ... (  )
	//friend ByteLenta operator + (const ByteLenta& LLenta, const ByteLenta& RLenta);
ByteLenta operator + (ByteLenta& LLenta, ByteLenta& RLenta);












//    ...
//      -   ...
//       -      ...

	// TGA, BMP, PNG, DDS, JPG, TEX
sStr NameTypeImageUni( sStr  File_NameDotU );








class str3int
{
public:
	int int1, int2, int3, zero;

	str3int() : int1(0), int2(0), int3(0), zero(0)
	{}

	void LoadText(const char* str12);
	void LoadFromStreamLine( std::ifstream &frs );
	char* pCharStr();
};


void str3intWrite( str3int& Name12, FILE* ff);

void str3intRead( str3int& Name12, FILE* ff);




	// --------------
	// 18Dec2005

class BinBlok
{
public:
//       BinBloFwd
void start( FILE* ff);

//       BinBloNextPart()
void fwd();

//       
void end( FILE* ff);

private:
int BinBlo_rePosition;
int BinBlo_reElemKlv;
};













int IntWriteMem( int* intZero, int* intZeroLast, FILE* ff,  int LimKlv=300);

int IntReadToMem( int* intZero, int* intZeroLast, FILE* ff,  int LimKlv=300);

int FloWriteMem( float* floZero, float* floZeroLast, FILE* ff,  int LimKlv=300);

int FloReadToMem( float* floZero, float* floZeroLast, FILE* ff,  int LimKlv=300);


int WriteToMem( int* intZero, int* intZeroLast, int zna, int LimKlv=300);





int GetByteLenta( ByteLenta& bbb, sStr name, sStr ext, sStr arh, UINT sverka=0 );





const char ctCHFile_W[] = {'w', '\0'};
const char ctCHFile_R[] =  {'r', '\0'};
const char ctCHFile_WB[] = {'w', 'b', '\0'};
const char ctCHFile_RB[] =  {'r', 'b', '\0'};

const char chStringNameNone[] =  "none";






class t_FileDirStek
{
public:

	t_FileDirStek(WORD dir_LAST);

	~t_FileDirStek();

	void Reset();

	void _SaveStartPoint();

	void CallStartPoint();


		//  -       ...
		//    AnStartPoint  - -   -
	int PushDir();

		//     PushDir
	int PopDir();


private:
	t_Char256* dir;

	WORD dir_Last;
	WORD now;

}; // t_FileDirStek


//extern t_FileDirStek  FileDir1; //  
	//mem.cpp// t_FileDirStek  FileDir1(8);  PopDir





	// ------------------


const sStr ctZaglavName = "zaglav.bin";



void Run_BakSysZaglav( sStr s1 );

int errPopD(); //   -,  -  

int SysZaglavForSave( sStr s1 );


int SysZaglavForLoad( sStr s1 );





